#ifndef _H_72B88F621E522131EE43AE6EB6C40A05_ActivityItem__H_
#define _H_72B88F621E522131EE43AE6EB6C40A05_ActivityItem__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace py_trees_ros_interfaces
{
    namespace msg
    {
        namespace dds_
        {
            namespace ActivityItem_Constants
            {
                const ::DDS::String_mgr READ_ = "READ";

                const ::DDS::String_mgr INITIALISED_ = "INITIALISED";

                const ::DDS::String_mgr WRITE_ = "WRITE";

                const ::DDS::String_mgr ACCESSED_ = "ACCESSED";

                const ::DDS::String_mgr ACCESS_DENIED_ = "ACCESS_DENIED";

                const ::DDS::String_mgr NO_KEY_ = "NO_KEY";

                const ::DDS::String_mgr NO_OVERWRITE_ = "NO_OVERWRITE";

                const ::DDS::String_mgr UNSET_ = "UNSET";

            }

            struct  ActivityItem_
            {
                ::DDS::String_mgr key_;
                ::DDS::String_mgr client_name_;
                ::DDS::String_mgr activity_type_;
                ::DDS::String_mgr previous_value_;
                ::DDS::String_mgr current_value_;
            };

            typedef DDS_DCPSStruct_var<ActivityItem_> ActivityItem__var;
            typedef DDS_DCPSStruct_out < ActivityItem_> ActivityItem__out;

        }

    }

}

#endif /* _H_72B88F621E522131EE43AE6EB6C40A05_ActivityItem__H_ */
