#ifndef _H_27CA188DA59D8BB56041EC75FAD5A6B2_ServiceDetails_DCPS_H_
#define _H_27CA188DA59D8BB56041EC75FAD5A6B2_ServiceDetails_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ServiceDetails_.h"


namespace py_trees_ros_interfaces
{
    namespace msg
    {
        namespace dds_
        {
            class ServiceDetails_TypeSupportInterface;

            typedef ServiceDetails_TypeSupportInterface * ServiceDetails_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ServiceDetails_TypeSupportInterface> ServiceDetails_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ServiceDetails_TypeSupportInterface> ServiceDetails_TypeSupportInterface_out;


            class ServiceDetails_DataWriter;

            typedef ServiceDetails_DataWriter * ServiceDetails_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ServiceDetails_DataWriter> ServiceDetails_DataWriter_var;
            typedef DDS_DCPSInterface_out < ServiceDetails_DataWriter> ServiceDetails_DataWriter_out;


            class ServiceDetails_DataReader;

            typedef ServiceDetails_DataReader * ServiceDetails_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ServiceDetails_DataReader> ServiceDetails_DataReader_var;
            typedef DDS_DCPSInterface_out < ServiceDetails_DataReader> ServiceDetails_DataReader_out;


            class ServiceDetails_DataReaderView;

            typedef ServiceDetails_DataReaderView * ServiceDetails_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ServiceDetails_DataReaderView> ServiceDetails_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ServiceDetails_DataReaderView> ServiceDetails_DataReaderView_out;

            struct ServiceDetails_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ServiceDetails_, struct ServiceDetails_Seq_uniq_> ServiceDetails_Seq;
            typedef DDS_DCPSSequence_var < ServiceDetails_Seq> ServiceDetails_Seq_var;
            typedef DDS_DCPSSequence_out < ServiceDetails_Seq> ServiceDetails_Seq_out;

            class  ServiceDetails_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ServiceDetails_TypeSupportInterface_ptr _ptr_type;
                typedef ServiceDetails_TypeSupportInterface_var _var_type;

                static ServiceDetails_TypeSupportInterface_ptr _duplicate (ServiceDetails_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceDetails_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ServiceDetails_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceDetails_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceDetails_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ServiceDetails_TypeSupportInterface () {};
                ~ServiceDetails_TypeSupportInterface () {};
            private:
                ServiceDetails_TypeSupportInterface (const ServiceDetails_TypeSupportInterface &);
                ServiceDetails_TypeSupportInterface & operator = (const ServiceDetails_TypeSupportInterface &);
            };

            class  ServiceDetails_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ServiceDetails_DataWriter_ptr _ptr_type;
                typedef ServiceDetails_DataWriter_var _var_type;

                static ServiceDetails_DataWriter_ptr _duplicate (ServiceDetails_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceDetails_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ServiceDetails_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceDetails_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceDetails_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ServiceDetails_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ServiceDetails_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ServiceDetails_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ServiceDetails_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ServiceDetails_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ServiceDetails_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ServiceDetails_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ServiceDetails_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ServiceDetails_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ServiceDetails_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ServiceDetails_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ServiceDetails_& instance_data) = 0;

            protected:
                ServiceDetails_DataWriter () {};
                ~ServiceDetails_DataWriter () {};
            private:
                ServiceDetails_DataWriter (const ServiceDetails_DataWriter &);
                ServiceDetails_DataWriter & operator = (const ServiceDetails_DataWriter &);
            };

            class  ServiceDetails_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ServiceDetails_DataReader_ptr _ptr_type;
                typedef ServiceDetails_DataReader_var _var_type;

                static ServiceDetails_DataReader_ptr _duplicate (ServiceDetails_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceDetails_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ServiceDetails_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceDetails_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceDetails_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ServiceDetails_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ServiceDetails_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ServiceDetails_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ServiceDetails_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ServiceDetails_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ServiceDetails_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ServiceDetails_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ServiceDetails_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ServiceDetails_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ServiceDetails_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ServiceDetails_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ServiceDetails_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ServiceDetails_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ServiceDetails_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ServiceDetails_& instance) = 0;

            protected:
                ServiceDetails_DataReader () {};
                ~ServiceDetails_DataReader () {};
            private:
                ServiceDetails_DataReader (const ServiceDetails_DataReader &);
                ServiceDetails_DataReader & operator = (const ServiceDetails_DataReader &);
            };

            class  ServiceDetails_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ServiceDetails_DataReaderView_ptr _ptr_type;
                typedef ServiceDetails_DataReaderView_var _var_type;

                static ServiceDetails_DataReaderView_ptr _duplicate (ServiceDetails_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ServiceDetails_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ServiceDetails_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ServiceDetails_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ServiceDetails_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ServiceDetails_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ServiceDetails_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ServiceDetails_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ServiceDetails_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ServiceDetails_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ServiceDetails_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ServiceDetails_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ServiceDetails_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ServiceDetails_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ServiceDetails_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ServiceDetails_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ServiceDetails_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ServiceDetails_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ServiceDetails_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ServiceDetails_& instance) = 0;

            protected:
                ServiceDetails_DataReaderView () {};
                ~ServiceDetails_DataReaderView () {};
            private:
                ServiceDetails_DataReaderView (const ServiceDetails_DataReaderView &);
                ServiceDetails_DataReaderView & operator = (const ServiceDetails_DataReaderView &);
            };
        }

    }

}

#endif
