#ifndef _H_AB1C2701D99DC4742D9858122CEA0C3E_SnapshotStreamParameters_DCPS_H_
#define _H_AB1C2701D99DC4742D9858122CEA0C3E_SnapshotStreamParameters_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SnapshotStreamParameters_.h"


namespace py_trees_ros_interfaces
{
    namespace msg
    {
        namespace dds_
        {
            class SnapshotStreamParameters_TypeSupportInterface;

            typedef SnapshotStreamParameters_TypeSupportInterface * SnapshotStreamParameters_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SnapshotStreamParameters_TypeSupportInterface> SnapshotStreamParameters_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SnapshotStreamParameters_TypeSupportInterface> SnapshotStreamParameters_TypeSupportInterface_out;


            class SnapshotStreamParameters_DataWriter;

            typedef SnapshotStreamParameters_DataWriter * SnapshotStreamParameters_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SnapshotStreamParameters_DataWriter> SnapshotStreamParameters_DataWriter_var;
            typedef DDS_DCPSInterface_out < SnapshotStreamParameters_DataWriter> SnapshotStreamParameters_DataWriter_out;


            class SnapshotStreamParameters_DataReader;

            typedef SnapshotStreamParameters_DataReader * SnapshotStreamParameters_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SnapshotStreamParameters_DataReader> SnapshotStreamParameters_DataReader_var;
            typedef DDS_DCPSInterface_out < SnapshotStreamParameters_DataReader> SnapshotStreamParameters_DataReader_out;


            class SnapshotStreamParameters_DataReaderView;

            typedef SnapshotStreamParameters_DataReaderView * SnapshotStreamParameters_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SnapshotStreamParameters_DataReaderView> SnapshotStreamParameters_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SnapshotStreamParameters_DataReaderView> SnapshotStreamParameters_DataReaderView_out;

            struct SnapshotStreamParameters_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < SnapshotStreamParameters_, struct SnapshotStreamParameters_Seq_uniq_> SnapshotStreamParameters_Seq;
            typedef DDS_DCPSSequence_var < SnapshotStreamParameters_Seq> SnapshotStreamParameters_Seq_var;
            typedef DDS_DCPSSequence_out < SnapshotStreamParameters_Seq> SnapshotStreamParameters_Seq_out;

            class  SnapshotStreamParameters_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SnapshotStreamParameters_TypeSupportInterface_ptr _ptr_type;
                typedef SnapshotStreamParameters_TypeSupportInterface_var _var_type;

                static SnapshotStreamParameters_TypeSupportInterface_ptr _duplicate (SnapshotStreamParameters_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SnapshotStreamParameters_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SnapshotStreamParameters_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SnapshotStreamParameters_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SnapshotStreamParameters_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SnapshotStreamParameters_TypeSupportInterface () {};
                ~SnapshotStreamParameters_TypeSupportInterface () {};
            private:
                SnapshotStreamParameters_TypeSupportInterface (const SnapshotStreamParameters_TypeSupportInterface &);
                SnapshotStreamParameters_TypeSupportInterface & operator = (const SnapshotStreamParameters_TypeSupportInterface &);
            };

            class  SnapshotStreamParameters_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SnapshotStreamParameters_DataWriter_ptr _ptr_type;
                typedef SnapshotStreamParameters_DataWriter_var _var_type;

                static SnapshotStreamParameters_DataWriter_ptr _duplicate (SnapshotStreamParameters_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SnapshotStreamParameters_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SnapshotStreamParameters_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SnapshotStreamParameters_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SnapshotStreamParameters_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SnapshotStreamParameters_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SnapshotStreamParameters_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SnapshotStreamParameters_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SnapshotStreamParameters_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SnapshotStreamParameters_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SnapshotStreamParameters_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SnapshotStreamParameters_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SnapshotStreamParameters_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SnapshotStreamParameters_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SnapshotStreamParameters_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SnapshotStreamParameters_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SnapshotStreamParameters_& instance_data) = 0;

            protected:
                SnapshotStreamParameters_DataWriter () {};
                ~SnapshotStreamParameters_DataWriter () {};
            private:
                SnapshotStreamParameters_DataWriter (const SnapshotStreamParameters_DataWriter &);
                SnapshotStreamParameters_DataWriter & operator = (const SnapshotStreamParameters_DataWriter &);
            };

            class  SnapshotStreamParameters_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SnapshotStreamParameters_DataReader_ptr _ptr_type;
                typedef SnapshotStreamParameters_DataReader_var _var_type;

                static SnapshotStreamParameters_DataReader_ptr _duplicate (SnapshotStreamParameters_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SnapshotStreamParameters_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SnapshotStreamParameters_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SnapshotStreamParameters_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SnapshotStreamParameters_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SnapshotStreamParameters_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SnapshotStreamParameters_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SnapshotStreamParameters_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SnapshotStreamParameters_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SnapshotStreamParameters_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SnapshotStreamParameters_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SnapshotStreamParameters_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SnapshotStreamParameters_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SnapshotStreamParameters_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SnapshotStreamParameters_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SnapshotStreamParameters_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SnapshotStreamParameters_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SnapshotStreamParameters_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SnapshotStreamParameters_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SnapshotStreamParameters_& instance) = 0;

            protected:
                SnapshotStreamParameters_DataReader () {};
                ~SnapshotStreamParameters_DataReader () {};
            private:
                SnapshotStreamParameters_DataReader (const SnapshotStreamParameters_DataReader &);
                SnapshotStreamParameters_DataReader & operator = (const SnapshotStreamParameters_DataReader &);
            };

            class  SnapshotStreamParameters_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SnapshotStreamParameters_DataReaderView_ptr _ptr_type;
                typedef SnapshotStreamParameters_DataReaderView_var _var_type;

                static SnapshotStreamParameters_DataReaderView_ptr _duplicate (SnapshotStreamParameters_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SnapshotStreamParameters_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SnapshotStreamParameters_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SnapshotStreamParameters_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SnapshotStreamParameters_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SnapshotStreamParameters_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SnapshotStreamParameters_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SnapshotStreamParameters_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SnapshotStreamParameters_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SnapshotStreamParameters_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SnapshotStreamParameters_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SnapshotStreamParameters_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SnapshotStreamParameters_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SnapshotStreamParameters_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SnapshotStreamParameters_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SnapshotStreamParameters_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SnapshotStreamParameters_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SnapshotStreamParameters_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SnapshotStreamParameters_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SnapshotStreamParameters_& instance) = 0;

            protected:
                SnapshotStreamParameters_DataReaderView () {};
                ~SnapshotStreamParameters_DataReaderView () {};
            private:
                SnapshotStreamParameters_DataReaderView (const SnapshotStreamParameters_DataReaderView &);
                SnapshotStreamParameters_DataReaderView & operator = (const SnapshotStreamParameters_DataReaderView &);
            };
        }

    }

}

#endif
