#ifndef _H_90E46570B9BD666C5BCC3A015A3F2BCA_CloseBlackboardStream_DCPS_H_
#define _H_90E46570B9BD666C5BCC3A015A3F2BCA_CloseBlackboardStream_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "CloseBlackboardStream_.h"


namespace py_trees_ros_interfaces
{
    namespace srv
    {
        namespace dds_
        {
            class CloseBlackboardStream_Request_TypeSupportInterface;

            typedef CloseBlackboardStream_Request_TypeSupportInterface * CloseBlackboardStream_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < CloseBlackboardStream_Request_TypeSupportInterface> CloseBlackboardStream_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < CloseBlackboardStream_Request_TypeSupportInterface> CloseBlackboardStream_Request_TypeSupportInterface_out;


            class CloseBlackboardStream_Request_DataWriter;

            typedef CloseBlackboardStream_Request_DataWriter * CloseBlackboardStream_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < CloseBlackboardStream_Request_DataWriter> CloseBlackboardStream_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < CloseBlackboardStream_Request_DataWriter> CloseBlackboardStream_Request_DataWriter_out;


            class CloseBlackboardStream_Request_DataReader;

            typedef CloseBlackboardStream_Request_DataReader * CloseBlackboardStream_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < CloseBlackboardStream_Request_DataReader> CloseBlackboardStream_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < CloseBlackboardStream_Request_DataReader> CloseBlackboardStream_Request_DataReader_out;


            class CloseBlackboardStream_Request_DataReaderView;

            typedef CloseBlackboardStream_Request_DataReaderView * CloseBlackboardStream_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < CloseBlackboardStream_Request_DataReaderView> CloseBlackboardStream_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < CloseBlackboardStream_Request_DataReaderView> CloseBlackboardStream_Request_DataReaderView_out;

            struct CloseBlackboardStream_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < CloseBlackboardStream_Request_, struct CloseBlackboardStream_Request_Seq_uniq_> CloseBlackboardStream_Request_Seq;
            typedef DDS_DCPSSequence_var < CloseBlackboardStream_Request_Seq> CloseBlackboardStream_Request_Seq_var;
            typedef DDS_DCPSSequence_out < CloseBlackboardStream_Request_Seq> CloseBlackboardStream_Request_Seq_out;

            class  CloseBlackboardStream_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef CloseBlackboardStream_Request_TypeSupportInterface_ptr _ptr_type;
                typedef CloseBlackboardStream_Request_TypeSupportInterface_var _var_type;

                static CloseBlackboardStream_Request_TypeSupportInterface_ptr _duplicate (CloseBlackboardStream_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CloseBlackboardStream_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static CloseBlackboardStream_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CloseBlackboardStream_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                CloseBlackboardStream_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                CloseBlackboardStream_Request_TypeSupportInterface () {};
                ~CloseBlackboardStream_Request_TypeSupportInterface () {};
            private:
                CloseBlackboardStream_Request_TypeSupportInterface (const CloseBlackboardStream_Request_TypeSupportInterface &);
                CloseBlackboardStream_Request_TypeSupportInterface & operator = (const CloseBlackboardStream_Request_TypeSupportInterface &);
            };

            class  CloseBlackboardStream_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef CloseBlackboardStream_Request_DataWriter_ptr _ptr_type;
                typedef CloseBlackboardStream_Request_DataWriter_var _var_type;

                static CloseBlackboardStream_Request_DataWriter_ptr _duplicate (CloseBlackboardStream_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CloseBlackboardStream_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static CloseBlackboardStream_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CloseBlackboardStream_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                CloseBlackboardStream_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const CloseBlackboardStream_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const CloseBlackboardStream_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const CloseBlackboardStream_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const CloseBlackboardStream_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const CloseBlackboardStream_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const CloseBlackboardStream_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const CloseBlackboardStream_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const CloseBlackboardStream_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const CloseBlackboardStream_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const CloseBlackboardStream_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (CloseBlackboardStream_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CloseBlackboardStream_Request_& instance_data) = 0;

            protected:
                CloseBlackboardStream_Request_DataWriter () {};
                ~CloseBlackboardStream_Request_DataWriter () {};
            private:
                CloseBlackboardStream_Request_DataWriter (const CloseBlackboardStream_Request_DataWriter &);
                CloseBlackboardStream_Request_DataWriter & operator = (const CloseBlackboardStream_Request_DataWriter &);
            };

            class  CloseBlackboardStream_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef CloseBlackboardStream_Request_DataReader_ptr _ptr_type;
                typedef CloseBlackboardStream_Request_DataReader_var _var_type;

                static CloseBlackboardStream_Request_DataReader_ptr _duplicate (CloseBlackboardStream_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CloseBlackboardStream_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static CloseBlackboardStream_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CloseBlackboardStream_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                CloseBlackboardStream_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (CloseBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (CloseBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (CloseBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (CloseBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (CloseBlackboardStream_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (CloseBlackboardStream_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (CloseBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (CloseBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (CloseBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (CloseBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (CloseBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (CloseBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (CloseBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (CloseBlackboardStream_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CloseBlackboardStream_Request_& instance) = 0;

            protected:
                CloseBlackboardStream_Request_DataReader () {};
                ~CloseBlackboardStream_Request_DataReader () {};
            private:
                CloseBlackboardStream_Request_DataReader (const CloseBlackboardStream_Request_DataReader &);
                CloseBlackboardStream_Request_DataReader & operator = (const CloseBlackboardStream_Request_DataReader &);
            };

            class  CloseBlackboardStream_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef CloseBlackboardStream_Request_DataReaderView_ptr _ptr_type;
                typedef CloseBlackboardStream_Request_DataReaderView_var _var_type;

                static CloseBlackboardStream_Request_DataReaderView_ptr _duplicate (CloseBlackboardStream_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CloseBlackboardStream_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static CloseBlackboardStream_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CloseBlackboardStream_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                CloseBlackboardStream_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (CloseBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (CloseBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (CloseBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (CloseBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (CloseBlackboardStream_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (CloseBlackboardStream_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (CloseBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (CloseBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (CloseBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (CloseBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (CloseBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (CloseBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (CloseBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (CloseBlackboardStream_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CloseBlackboardStream_Request_& instance) = 0;

            protected:
                CloseBlackboardStream_Request_DataReaderView () {};
                ~CloseBlackboardStream_Request_DataReaderView () {};
            private:
                CloseBlackboardStream_Request_DataReaderView (const CloseBlackboardStream_Request_DataReaderView &);
                CloseBlackboardStream_Request_DataReaderView & operator = (const CloseBlackboardStream_Request_DataReaderView &);
            };
            class CloseBlackboardStream_Response_TypeSupportInterface;

            typedef CloseBlackboardStream_Response_TypeSupportInterface * CloseBlackboardStream_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < CloseBlackboardStream_Response_TypeSupportInterface> CloseBlackboardStream_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < CloseBlackboardStream_Response_TypeSupportInterface> CloseBlackboardStream_Response_TypeSupportInterface_out;


            class CloseBlackboardStream_Response_DataWriter;

            typedef CloseBlackboardStream_Response_DataWriter * CloseBlackboardStream_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < CloseBlackboardStream_Response_DataWriter> CloseBlackboardStream_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < CloseBlackboardStream_Response_DataWriter> CloseBlackboardStream_Response_DataWriter_out;


            class CloseBlackboardStream_Response_DataReader;

            typedef CloseBlackboardStream_Response_DataReader * CloseBlackboardStream_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < CloseBlackboardStream_Response_DataReader> CloseBlackboardStream_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < CloseBlackboardStream_Response_DataReader> CloseBlackboardStream_Response_DataReader_out;


            class CloseBlackboardStream_Response_DataReaderView;

            typedef CloseBlackboardStream_Response_DataReaderView * CloseBlackboardStream_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < CloseBlackboardStream_Response_DataReaderView> CloseBlackboardStream_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < CloseBlackboardStream_Response_DataReaderView> CloseBlackboardStream_Response_DataReaderView_out;

            struct CloseBlackboardStream_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < CloseBlackboardStream_Response_, struct CloseBlackboardStream_Response_Seq_uniq_> CloseBlackboardStream_Response_Seq;
            typedef DDS_DCPSSequence_var < CloseBlackboardStream_Response_Seq> CloseBlackboardStream_Response_Seq_var;
            typedef DDS_DCPSSequence_out < CloseBlackboardStream_Response_Seq> CloseBlackboardStream_Response_Seq_out;

            class  CloseBlackboardStream_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef CloseBlackboardStream_Response_TypeSupportInterface_ptr _ptr_type;
                typedef CloseBlackboardStream_Response_TypeSupportInterface_var _var_type;

                static CloseBlackboardStream_Response_TypeSupportInterface_ptr _duplicate (CloseBlackboardStream_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CloseBlackboardStream_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static CloseBlackboardStream_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CloseBlackboardStream_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                CloseBlackboardStream_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                CloseBlackboardStream_Response_TypeSupportInterface () {};
                ~CloseBlackboardStream_Response_TypeSupportInterface () {};
            private:
                CloseBlackboardStream_Response_TypeSupportInterface (const CloseBlackboardStream_Response_TypeSupportInterface &);
                CloseBlackboardStream_Response_TypeSupportInterface & operator = (const CloseBlackboardStream_Response_TypeSupportInterface &);
            };

            class  CloseBlackboardStream_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef CloseBlackboardStream_Response_DataWriter_ptr _ptr_type;
                typedef CloseBlackboardStream_Response_DataWriter_var _var_type;

                static CloseBlackboardStream_Response_DataWriter_ptr _duplicate (CloseBlackboardStream_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CloseBlackboardStream_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static CloseBlackboardStream_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CloseBlackboardStream_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                CloseBlackboardStream_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const CloseBlackboardStream_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const CloseBlackboardStream_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const CloseBlackboardStream_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const CloseBlackboardStream_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const CloseBlackboardStream_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const CloseBlackboardStream_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const CloseBlackboardStream_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const CloseBlackboardStream_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const CloseBlackboardStream_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const CloseBlackboardStream_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (CloseBlackboardStream_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CloseBlackboardStream_Response_& instance_data) = 0;

            protected:
                CloseBlackboardStream_Response_DataWriter () {};
                ~CloseBlackboardStream_Response_DataWriter () {};
            private:
                CloseBlackboardStream_Response_DataWriter (const CloseBlackboardStream_Response_DataWriter &);
                CloseBlackboardStream_Response_DataWriter & operator = (const CloseBlackboardStream_Response_DataWriter &);
            };

            class  CloseBlackboardStream_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef CloseBlackboardStream_Response_DataReader_ptr _ptr_type;
                typedef CloseBlackboardStream_Response_DataReader_var _var_type;

                static CloseBlackboardStream_Response_DataReader_ptr _duplicate (CloseBlackboardStream_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CloseBlackboardStream_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static CloseBlackboardStream_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CloseBlackboardStream_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                CloseBlackboardStream_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (CloseBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (CloseBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (CloseBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (CloseBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (CloseBlackboardStream_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (CloseBlackboardStream_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (CloseBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (CloseBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (CloseBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (CloseBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (CloseBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (CloseBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (CloseBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (CloseBlackboardStream_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CloseBlackboardStream_Response_& instance) = 0;

            protected:
                CloseBlackboardStream_Response_DataReader () {};
                ~CloseBlackboardStream_Response_DataReader () {};
            private:
                CloseBlackboardStream_Response_DataReader (const CloseBlackboardStream_Response_DataReader &);
                CloseBlackboardStream_Response_DataReader & operator = (const CloseBlackboardStream_Response_DataReader &);
            };

            class  CloseBlackboardStream_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef CloseBlackboardStream_Response_DataReaderView_ptr _ptr_type;
                typedef CloseBlackboardStream_Response_DataReaderView_var _var_type;

                static CloseBlackboardStream_Response_DataReaderView_ptr _duplicate (CloseBlackboardStream_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CloseBlackboardStream_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static CloseBlackboardStream_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CloseBlackboardStream_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                CloseBlackboardStream_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (CloseBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (CloseBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (CloseBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (CloseBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (CloseBlackboardStream_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (CloseBlackboardStream_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (CloseBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (CloseBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (CloseBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (CloseBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (CloseBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (CloseBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (CloseBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (CloseBlackboardStream_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CloseBlackboardStream_Response_& instance) = 0;

            protected:
                CloseBlackboardStream_Response_DataReaderView () {};
                ~CloseBlackboardStream_Response_DataReaderView () {};
            private:
                CloseBlackboardStream_Response_DataReaderView (const CloseBlackboardStream_Response_DataReaderView &);
                CloseBlackboardStream_Response_DataReaderView & operator = (const CloseBlackboardStream_Response_DataReaderView &);
            };
            class Sample_CloseBlackboardStream_Request_TypeSupportInterface;

            typedef Sample_CloseBlackboardStream_Request_TypeSupportInterface * Sample_CloseBlackboardStream_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_CloseBlackboardStream_Request_TypeSupportInterface> Sample_CloseBlackboardStream_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_CloseBlackboardStream_Request_TypeSupportInterface> Sample_CloseBlackboardStream_Request_TypeSupportInterface_out;


            class Sample_CloseBlackboardStream_Request_DataWriter;

            typedef Sample_CloseBlackboardStream_Request_DataWriter * Sample_CloseBlackboardStream_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_CloseBlackboardStream_Request_DataWriter> Sample_CloseBlackboardStream_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_CloseBlackboardStream_Request_DataWriter> Sample_CloseBlackboardStream_Request_DataWriter_out;


            class Sample_CloseBlackboardStream_Request_DataReader;

            typedef Sample_CloseBlackboardStream_Request_DataReader * Sample_CloseBlackboardStream_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_CloseBlackboardStream_Request_DataReader> Sample_CloseBlackboardStream_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_CloseBlackboardStream_Request_DataReader> Sample_CloseBlackboardStream_Request_DataReader_out;


            class Sample_CloseBlackboardStream_Request_DataReaderView;

            typedef Sample_CloseBlackboardStream_Request_DataReaderView * Sample_CloseBlackboardStream_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_CloseBlackboardStream_Request_DataReaderView> Sample_CloseBlackboardStream_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_CloseBlackboardStream_Request_DataReaderView> Sample_CloseBlackboardStream_Request_DataReaderView_out;

            struct Sample_CloseBlackboardStream_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_CloseBlackboardStream_Request_, struct Sample_CloseBlackboardStream_Request_Seq_uniq_> Sample_CloseBlackboardStream_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_CloseBlackboardStream_Request_Seq> Sample_CloseBlackboardStream_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_CloseBlackboardStream_Request_Seq> Sample_CloseBlackboardStream_Request_Seq_out;

            class  Sample_CloseBlackboardStream_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_CloseBlackboardStream_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_CloseBlackboardStream_Request_TypeSupportInterface_var _var_type;

                static Sample_CloseBlackboardStream_Request_TypeSupportInterface_ptr _duplicate (Sample_CloseBlackboardStream_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_CloseBlackboardStream_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_CloseBlackboardStream_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_CloseBlackboardStream_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_CloseBlackboardStream_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_CloseBlackboardStream_Request_TypeSupportInterface () {};
                ~Sample_CloseBlackboardStream_Request_TypeSupportInterface () {};
            private:
                Sample_CloseBlackboardStream_Request_TypeSupportInterface (const Sample_CloseBlackboardStream_Request_TypeSupportInterface &);
                Sample_CloseBlackboardStream_Request_TypeSupportInterface & operator = (const Sample_CloseBlackboardStream_Request_TypeSupportInterface &);
            };

            class  Sample_CloseBlackboardStream_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_CloseBlackboardStream_Request_DataWriter_ptr _ptr_type;
                typedef Sample_CloseBlackboardStream_Request_DataWriter_var _var_type;

                static Sample_CloseBlackboardStream_Request_DataWriter_ptr _duplicate (Sample_CloseBlackboardStream_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_CloseBlackboardStream_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_CloseBlackboardStream_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_CloseBlackboardStream_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_CloseBlackboardStream_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_CloseBlackboardStream_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_CloseBlackboardStream_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_CloseBlackboardStream_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_CloseBlackboardStream_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_CloseBlackboardStream_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_CloseBlackboardStream_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_CloseBlackboardStream_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_CloseBlackboardStream_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_CloseBlackboardStream_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_CloseBlackboardStream_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_CloseBlackboardStream_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_CloseBlackboardStream_Request_& instance_data) = 0;

            protected:
                Sample_CloseBlackboardStream_Request_DataWriter () {};
                ~Sample_CloseBlackboardStream_Request_DataWriter () {};
            private:
                Sample_CloseBlackboardStream_Request_DataWriter (const Sample_CloseBlackboardStream_Request_DataWriter &);
                Sample_CloseBlackboardStream_Request_DataWriter & operator = (const Sample_CloseBlackboardStream_Request_DataWriter &);
            };

            class  Sample_CloseBlackboardStream_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_CloseBlackboardStream_Request_DataReader_ptr _ptr_type;
                typedef Sample_CloseBlackboardStream_Request_DataReader_var _var_type;

                static Sample_CloseBlackboardStream_Request_DataReader_ptr _duplicate (Sample_CloseBlackboardStream_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_CloseBlackboardStream_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_CloseBlackboardStream_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_CloseBlackboardStream_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_CloseBlackboardStream_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_CloseBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_CloseBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_CloseBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_CloseBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_CloseBlackboardStream_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_CloseBlackboardStream_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_CloseBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_CloseBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_CloseBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_CloseBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_CloseBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_CloseBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_CloseBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_CloseBlackboardStream_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_CloseBlackboardStream_Request_& instance) = 0;

            protected:
                Sample_CloseBlackboardStream_Request_DataReader () {};
                ~Sample_CloseBlackboardStream_Request_DataReader () {};
            private:
                Sample_CloseBlackboardStream_Request_DataReader (const Sample_CloseBlackboardStream_Request_DataReader &);
                Sample_CloseBlackboardStream_Request_DataReader & operator = (const Sample_CloseBlackboardStream_Request_DataReader &);
            };

            class  Sample_CloseBlackboardStream_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_CloseBlackboardStream_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_CloseBlackboardStream_Request_DataReaderView_var _var_type;

                static Sample_CloseBlackboardStream_Request_DataReaderView_ptr _duplicate (Sample_CloseBlackboardStream_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_CloseBlackboardStream_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_CloseBlackboardStream_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_CloseBlackboardStream_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_CloseBlackboardStream_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_CloseBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_CloseBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_CloseBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_CloseBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_CloseBlackboardStream_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_CloseBlackboardStream_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_CloseBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_CloseBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_CloseBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_CloseBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_CloseBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_CloseBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_CloseBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_CloseBlackboardStream_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_CloseBlackboardStream_Request_& instance) = 0;

            protected:
                Sample_CloseBlackboardStream_Request_DataReaderView () {};
                ~Sample_CloseBlackboardStream_Request_DataReaderView () {};
            private:
                Sample_CloseBlackboardStream_Request_DataReaderView (const Sample_CloseBlackboardStream_Request_DataReaderView &);
                Sample_CloseBlackboardStream_Request_DataReaderView & operator = (const Sample_CloseBlackboardStream_Request_DataReaderView &);
            };
            class Sample_CloseBlackboardStream_Response_TypeSupportInterface;

            typedef Sample_CloseBlackboardStream_Response_TypeSupportInterface * Sample_CloseBlackboardStream_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_CloseBlackboardStream_Response_TypeSupportInterface> Sample_CloseBlackboardStream_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_CloseBlackboardStream_Response_TypeSupportInterface> Sample_CloseBlackboardStream_Response_TypeSupportInterface_out;


            class Sample_CloseBlackboardStream_Response_DataWriter;

            typedef Sample_CloseBlackboardStream_Response_DataWriter * Sample_CloseBlackboardStream_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_CloseBlackboardStream_Response_DataWriter> Sample_CloseBlackboardStream_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_CloseBlackboardStream_Response_DataWriter> Sample_CloseBlackboardStream_Response_DataWriter_out;


            class Sample_CloseBlackboardStream_Response_DataReader;

            typedef Sample_CloseBlackboardStream_Response_DataReader * Sample_CloseBlackboardStream_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_CloseBlackboardStream_Response_DataReader> Sample_CloseBlackboardStream_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_CloseBlackboardStream_Response_DataReader> Sample_CloseBlackboardStream_Response_DataReader_out;


            class Sample_CloseBlackboardStream_Response_DataReaderView;

            typedef Sample_CloseBlackboardStream_Response_DataReaderView * Sample_CloseBlackboardStream_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_CloseBlackboardStream_Response_DataReaderView> Sample_CloseBlackboardStream_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_CloseBlackboardStream_Response_DataReaderView> Sample_CloseBlackboardStream_Response_DataReaderView_out;

            struct Sample_CloseBlackboardStream_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_CloseBlackboardStream_Response_, struct Sample_CloseBlackboardStream_Response_Seq_uniq_> Sample_CloseBlackboardStream_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_CloseBlackboardStream_Response_Seq> Sample_CloseBlackboardStream_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_CloseBlackboardStream_Response_Seq> Sample_CloseBlackboardStream_Response_Seq_out;

            class  Sample_CloseBlackboardStream_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_CloseBlackboardStream_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_CloseBlackboardStream_Response_TypeSupportInterface_var _var_type;

                static Sample_CloseBlackboardStream_Response_TypeSupportInterface_ptr _duplicate (Sample_CloseBlackboardStream_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_CloseBlackboardStream_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_CloseBlackboardStream_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_CloseBlackboardStream_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_CloseBlackboardStream_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_CloseBlackboardStream_Response_TypeSupportInterface () {};
                ~Sample_CloseBlackboardStream_Response_TypeSupportInterface () {};
            private:
                Sample_CloseBlackboardStream_Response_TypeSupportInterface (const Sample_CloseBlackboardStream_Response_TypeSupportInterface &);
                Sample_CloseBlackboardStream_Response_TypeSupportInterface & operator = (const Sample_CloseBlackboardStream_Response_TypeSupportInterface &);
            };

            class  Sample_CloseBlackboardStream_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_CloseBlackboardStream_Response_DataWriter_ptr _ptr_type;
                typedef Sample_CloseBlackboardStream_Response_DataWriter_var _var_type;

                static Sample_CloseBlackboardStream_Response_DataWriter_ptr _duplicate (Sample_CloseBlackboardStream_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_CloseBlackboardStream_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_CloseBlackboardStream_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_CloseBlackboardStream_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_CloseBlackboardStream_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_CloseBlackboardStream_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_CloseBlackboardStream_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_CloseBlackboardStream_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_CloseBlackboardStream_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_CloseBlackboardStream_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_CloseBlackboardStream_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_CloseBlackboardStream_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_CloseBlackboardStream_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_CloseBlackboardStream_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_CloseBlackboardStream_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_CloseBlackboardStream_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_CloseBlackboardStream_Response_& instance_data) = 0;

            protected:
                Sample_CloseBlackboardStream_Response_DataWriter () {};
                ~Sample_CloseBlackboardStream_Response_DataWriter () {};
            private:
                Sample_CloseBlackboardStream_Response_DataWriter (const Sample_CloseBlackboardStream_Response_DataWriter &);
                Sample_CloseBlackboardStream_Response_DataWriter & operator = (const Sample_CloseBlackboardStream_Response_DataWriter &);
            };

            class  Sample_CloseBlackboardStream_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_CloseBlackboardStream_Response_DataReader_ptr _ptr_type;
                typedef Sample_CloseBlackboardStream_Response_DataReader_var _var_type;

                static Sample_CloseBlackboardStream_Response_DataReader_ptr _duplicate (Sample_CloseBlackboardStream_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_CloseBlackboardStream_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_CloseBlackboardStream_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_CloseBlackboardStream_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_CloseBlackboardStream_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_CloseBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_CloseBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_CloseBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_CloseBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_CloseBlackboardStream_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_CloseBlackboardStream_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_CloseBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_CloseBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_CloseBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_CloseBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_CloseBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_CloseBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_CloseBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_CloseBlackboardStream_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_CloseBlackboardStream_Response_& instance) = 0;

            protected:
                Sample_CloseBlackboardStream_Response_DataReader () {};
                ~Sample_CloseBlackboardStream_Response_DataReader () {};
            private:
                Sample_CloseBlackboardStream_Response_DataReader (const Sample_CloseBlackboardStream_Response_DataReader &);
                Sample_CloseBlackboardStream_Response_DataReader & operator = (const Sample_CloseBlackboardStream_Response_DataReader &);
            };

            class  Sample_CloseBlackboardStream_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_CloseBlackboardStream_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_CloseBlackboardStream_Response_DataReaderView_var _var_type;

                static Sample_CloseBlackboardStream_Response_DataReaderView_ptr _duplicate (Sample_CloseBlackboardStream_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_CloseBlackboardStream_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_CloseBlackboardStream_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_CloseBlackboardStream_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_CloseBlackboardStream_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_CloseBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_CloseBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_CloseBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_CloseBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_CloseBlackboardStream_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_CloseBlackboardStream_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_CloseBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_CloseBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_CloseBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_CloseBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_CloseBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_CloseBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_CloseBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_CloseBlackboardStream_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_CloseBlackboardStream_Response_& instance) = 0;

            protected:
                Sample_CloseBlackboardStream_Response_DataReaderView () {};
                ~Sample_CloseBlackboardStream_Response_DataReaderView () {};
            private:
                Sample_CloseBlackboardStream_Response_DataReaderView (const Sample_CloseBlackboardStream_Response_DataReaderView &);
                Sample_CloseBlackboardStream_Response_DataReaderView & operator = (const Sample_CloseBlackboardStream_Response_DataReaderView &);
            };
        }

    }

}

#endif
