#ifndef _H_F00D6DFFBC303A9A317F21B135141F4E_CloseSnapshotStream__H_
#define _H_F00D6DFFBC303A9A317F21B135141F4E_CloseSnapshotStream__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace py_trees_ros_interfaces
{
    namespace srv
    {
        namespace dds_
        {
            struct  CloseSnapshotStream_Request_
            {
                ::DDS::String_mgr topic_name_;
            };

            typedef DDS_DCPSStruct_var<CloseSnapshotStream_Request_> CloseSnapshotStream_Request__var;
            typedef DDS_DCPSStruct_out < CloseSnapshotStream_Request_> CloseSnapshotStream_Request__out;

            struct  CloseSnapshotStream_Response_
            {
                ::DDS::Boolean result_;
            };

            typedef DDS_DCPSStruct_var<CloseSnapshotStream_Response_> CloseSnapshotStream_Response__var;
            typedef CloseSnapshotStream_Response_& CloseSnapshotStream_Response__out;

            struct  Sample_CloseSnapshotStream_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::py_trees_ros_interfaces::srv::dds_::CloseSnapshotStream_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_CloseSnapshotStream_Request_> Sample_CloseSnapshotStream_Request__var;
            typedef DDS_DCPSStruct_out < Sample_CloseSnapshotStream_Request_> Sample_CloseSnapshotStream_Request__out;

            struct  Sample_CloseSnapshotStream_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::py_trees_ros_interfaces::srv::dds_::CloseSnapshotStream_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_CloseSnapshotStream_Response_> Sample_CloseSnapshotStream_Response__var;
            typedef Sample_CloseSnapshotStream_Response_& Sample_CloseSnapshotStream_Response__out;

        }

    }

}

#endif /* _H_F00D6DFFBC303A9A317F21B135141F4E_CloseSnapshotStream__H_ */
