#ifndef _H_988EEAD2C4E0F7EB9C6D5DB5A483F5D3_OpenBlackboardStream_DCPS_H_
#define _H_988EEAD2C4E0F7EB9C6D5DB5A483F5D3_OpenBlackboardStream_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "OpenBlackboardStream_.h"


namespace py_trees_ros_interfaces
{
    namespace srv
    {
        namespace dds_
        {
            class OpenBlackboardStream_Request_TypeSupportInterface;

            typedef OpenBlackboardStream_Request_TypeSupportInterface * OpenBlackboardStream_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < OpenBlackboardStream_Request_TypeSupportInterface> OpenBlackboardStream_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < OpenBlackboardStream_Request_TypeSupportInterface> OpenBlackboardStream_Request_TypeSupportInterface_out;


            class OpenBlackboardStream_Request_DataWriter;

            typedef OpenBlackboardStream_Request_DataWriter * OpenBlackboardStream_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < OpenBlackboardStream_Request_DataWriter> OpenBlackboardStream_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < OpenBlackboardStream_Request_DataWriter> OpenBlackboardStream_Request_DataWriter_out;


            class OpenBlackboardStream_Request_DataReader;

            typedef OpenBlackboardStream_Request_DataReader * OpenBlackboardStream_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < OpenBlackboardStream_Request_DataReader> OpenBlackboardStream_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < OpenBlackboardStream_Request_DataReader> OpenBlackboardStream_Request_DataReader_out;


            class OpenBlackboardStream_Request_DataReaderView;

            typedef OpenBlackboardStream_Request_DataReaderView * OpenBlackboardStream_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < OpenBlackboardStream_Request_DataReaderView> OpenBlackboardStream_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < OpenBlackboardStream_Request_DataReaderView> OpenBlackboardStream_Request_DataReaderView_out;

            struct OpenBlackboardStream_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < OpenBlackboardStream_Request_, struct OpenBlackboardStream_Request_Seq_uniq_> OpenBlackboardStream_Request_Seq;
            typedef DDS_DCPSSequence_var < OpenBlackboardStream_Request_Seq> OpenBlackboardStream_Request_Seq_var;
            typedef DDS_DCPSSequence_out < OpenBlackboardStream_Request_Seq> OpenBlackboardStream_Request_Seq_out;

            class  OpenBlackboardStream_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef OpenBlackboardStream_Request_TypeSupportInterface_ptr _ptr_type;
                typedef OpenBlackboardStream_Request_TypeSupportInterface_var _var_type;

                static OpenBlackboardStream_Request_TypeSupportInterface_ptr _duplicate (OpenBlackboardStream_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static OpenBlackboardStream_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static OpenBlackboardStream_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static OpenBlackboardStream_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                OpenBlackboardStream_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                OpenBlackboardStream_Request_TypeSupportInterface () {};
                ~OpenBlackboardStream_Request_TypeSupportInterface () {};
            private:
                OpenBlackboardStream_Request_TypeSupportInterface (const OpenBlackboardStream_Request_TypeSupportInterface &);
                OpenBlackboardStream_Request_TypeSupportInterface & operator = (const OpenBlackboardStream_Request_TypeSupportInterface &);
            };

            class  OpenBlackboardStream_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef OpenBlackboardStream_Request_DataWriter_ptr _ptr_type;
                typedef OpenBlackboardStream_Request_DataWriter_var _var_type;

                static OpenBlackboardStream_Request_DataWriter_ptr _duplicate (OpenBlackboardStream_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static OpenBlackboardStream_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static OpenBlackboardStream_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static OpenBlackboardStream_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                OpenBlackboardStream_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const OpenBlackboardStream_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const OpenBlackboardStream_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const OpenBlackboardStream_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const OpenBlackboardStream_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const OpenBlackboardStream_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const OpenBlackboardStream_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const OpenBlackboardStream_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const OpenBlackboardStream_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const OpenBlackboardStream_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const OpenBlackboardStream_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (OpenBlackboardStream_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const OpenBlackboardStream_Request_& instance_data) = 0;

            protected:
                OpenBlackboardStream_Request_DataWriter () {};
                ~OpenBlackboardStream_Request_DataWriter () {};
            private:
                OpenBlackboardStream_Request_DataWriter (const OpenBlackboardStream_Request_DataWriter &);
                OpenBlackboardStream_Request_DataWriter & operator = (const OpenBlackboardStream_Request_DataWriter &);
            };

            class  OpenBlackboardStream_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef OpenBlackboardStream_Request_DataReader_ptr _ptr_type;
                typedef OpenBlackboardStream_Request_DataReader_var _var_type;

                static OpenBlackboardStream_Request_DataReader_ptr _duplicate (OpenBlackboardStream_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static OpenBlackboardStream_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static OpenBlackboardStream_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static OpenBlackboardStream_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                OpenBlackboardStream_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (OpenBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (OpenBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (OpenBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (OpenBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (OpenBlackboardStream_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (OpenBlackboardStream_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (OpenBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (OpenBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (OpenBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (OpenBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (OpenBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (OpenBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (OpenBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (OpenBlackboardStream_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const OpenBlackboardStream_Request_& instance) = 0;

            protected:
                OpenBlackboardStream_Request_DataReader () {};
                ~OpenBlackboardStream_Request_DataReader () {};
            private:
                OpenBlackboardStream_Request_DataReader (const OpenBlackboardStream_Request_DataReader &);
                OpenBlackboardStream_Request_DataReader & operator = (const OpenBlackboardStream_Request_DataReader &);
            };

            class  OpenBlackboardStream_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef OpenBlackboardStream_Request_DataReaderView_ptr _ptr_type;
                typedef OpenBlackboardStream_Request_DataReaderView_var _var_type;

                static OpenBlackboardStream_Request_DataReaderView_ptr _duplicate (OpenBlackboardStream_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static OpenBlackboardStream_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static OpenBlackboardStream_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static OpenBlackboardStream_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                OpenBlackboardStream_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (OpenBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (OpenBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (OpenBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (OpenBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (OpenBlackboardStream_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (OpenBlackboardStream_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (OpenBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (OpenBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (OpenBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (OpenBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (OpenBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (OpenBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (OpenBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (OpenBlackboardStream_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const OpenBlackboardStream_Request_& instance) = 0;

            protected:
                OpenBlackboardStream_Request_DataReaderView () {};
                ~OpenBlackboardStream_Request_DataReaderView () {};
            private:
                OpenBlackboardStream_Request_DataReaderView (const OpenBlackboardStream_Request_DataReaderView &);
                OpenBlackboardStream_Request_DataReaderView & operator = (const OpenBlackboardStream_Request_DataReaderView &);
            };
            class OpenBlackboardStream_Response_TypeSupportInterface;

            typedef OpenBlackboardStream_Response_TypeSupportInterface * OpenBlackboardStream_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < OpenBlackboardStream_Response_TypeSupportInterface> OpenBlackboardStream_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < OpenBlackboardStream_Response_TypeSupportInterface> OpenBlackboardStream_Response_TypeSupportInterface_out;


            class OpenBlackboardStream_Response_DataWriter;

            typedef OpenBlackboardStream_Response_DataWriter * OpenBlackboardStream_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < OpenBlackboardStream_Response_DataWriter> OpenBlackboardStream_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < OpenBlackboardStream_Response_DataWriter> OpenBlackboardStream_Response_DataWriter_out;


            class OpenBlackboardStream_Response_DataReader;

            typedef OpenBlackboardStream_Response_DataReader * OpenBlackboardStream_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < OpenBlackboardStream_Response_DataReader> OpenBlackboardStream_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < OpenBlackboardStream_Response_DataReader> OpenBlackboardStream_Response_DataReader_out;


            class OpenBlackboardStream_Response_DataReaderView;

            typedef OpenBlackboardStream_Response_DataReaderView * OpenBlackboardStream_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < OpenBlackboardStream_Response_DataReaderView> OpenBlackboardStream_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < OpenBlackboardStream_Response_DataReaderView> OpenBlackboardStream_Response_DataReaderView_out;

            struct OpenBlackboardStream_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < OpenBlackboardStream_Response_, struct OpenBlackboardStream_Response_Seq_uniq_> OpenBlackboardStream_Response_Seq;
            typedef DDS_DCPSSequence_var < OpenBlackboardStream_Response_Seq> OpenBlackboardStream_Response_Seq_var;
            typedef DDS_DCPSSequence_out < OpenBlackboardStream_Response_Seq> OpenBlackboardStream_Response_Seq_out;

            class  OpenBlackboardStream_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef OpenBlackboardStream_Response_TypeSupportInterface_ptr _ptr_type;
                typedef OpenBlackboardStream_Response_TypeSupportInterface_var _var_type;

                static OpenBlackboardStream_Response_TypeSupportInterface_ptr _duplicate (OpenBlackboardStream_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static OpenBlackboardStream_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static OpenBlackboardStream_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static OpenBlackboardStream_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                OpenBlackboardStream_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                OpenBlackboardStream_Response_TypeSupportInterface () {};
                ~OpenBlackboardStream_Response_TypeSupportInterface () {};
            private:
                OpenBlackboardStream_Response_TypeSupportInterface (const OpenBlackboardStream_Response_TypeSupportInterface &);
                OpenBlackboardStream_Response_TypeSupportInterface & operator = (const OpenBlackboardStream_Response_TypeSupportInterface &);
            };

            class  OpenBlackboardStream_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef OpenBlackboardStream_Response_DataWriter_ptr _ptr_type;
                typedef OpenBlackboardStream_Response_DataWriter_var _var_type;

                static OpenBlackboardStream_Response_DataWriter_ptr _duplicate (OpenBlackboardStream_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static OpenBlackboardStream_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static OpenBlackboardStream_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static OpenBlackboardStream_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                OpenBlackboardStream_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const OpenBlackboardStream_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const OpenBlackboardStream_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const OpenBlackboardStream_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const OpenBlackboardStream_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const OpenBlackboardStream_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const OpenBlackboardStream_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const OpenBlackboardStream_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const OpenBlackboardStream_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const OpenBlackboardStream_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const OpenBlackboardStream_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (OpenBlackboardStream_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const OpenBlackboardStream_Response_& instance_data) = 0;

            protected:
                OpenBlackboardStream_Response_DataWriter () {};
                ~OpenBlackboardStream_Response_DataWriter () {};
            private:
                OpenBlackboardStream_Response_DataWriter (const OpenBlackboardStream_Response_DataWriter &);
                OpenBlackboardStream_Response_DataWriter & operator = (const OpenBlackboardStream_Response_DataWriter &);
            };

            class  OpenBlackboardStream_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef OpenBlackboardStream_Response_DataReader_ptr _ptr_type;
                typedef OpenBlackboardStream_Response_DataReader_var _var_type;

                static OpenBlackboardStream_Response_DataReader_ptr _duplicate (OpenBlackboardStream_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static OpenBlackboardStream_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static OpenBlackboardStream_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static OpenBlackboardStream_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                OpenBlackboardStream_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (OpenBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (OpenBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (OpenBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (OpenBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (OpenBlackboardStream_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (OpenBlackboardStream_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (OpenBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (OpenBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (OpenBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (OpenBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (OpenBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (OpenBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (OpenBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (OpenBlackboardStream_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const OpenBlackboardStream_Response_& instance) = 0;

            protected:
                OpenBlackboardStream_Response_DataReader () {};
                ~OpenBlackboardStream_Response_DataReader () {};
            private:
                OpenBlackboardStream_Response_DataReader (const OpenBlackboardStream_Response_DataReader &);
                OpenBlackboardStream_Response_DataReader & operator = (const OpenBlackboardStream_Response_DataReader &);
            };

            class  OpenBlackboardStream_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef OpenBlackboardStream_Response_DataReaderView_ptr _ptr_type;
                typedef OpenBlackboardStream_Response_DataReaderView_var _var_type;

                static OpenBlackboardStream_Response_DataReaderView_ptr _duplicate (OpenBlackboardStream_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static OpenBlackboardStream_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static OpenBlackboardStream_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static OpenBlackboardStream_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                OpenBlackboardStream_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (OpenBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (OpenBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (OpenBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (OpenBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (OpenBlackboardStream_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (OpenBlackboardStream_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (OpenBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (OpenBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (OpenBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (OpenBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (OpenBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (OpenBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (OpenBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (OpenBlackboardStream_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const OpenBlackboardStream_Response_& instance) = 0;

            protected:
                OpenBlackboardStream_Response_DataReaderView () {};
                ~OpenBlackboardStream_Response_DataReaderView () {};
            private:
                OpenBlackboardStream_Response_DataReaderView (const OpenBlackboardStream_Response_DataReaderView &);
                OpenBlackboardStream_Response_DataReaderView & operator = (const OpenBlackboardStream_Response_DataReaderView &);
            };
            class Sample_OpenBlackboardStream_Request_TypeSupportInterface;

            typedef Sample_OpenBlackboardStream_Request_TypeSupportInterface * Sample_OpenBlackboardStream_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_OpenBlackboardStream_Request_TypeSupportInterface> Sample_OpenBlackboardStream_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_OpenBlackboardStream_Request_TypeSupportInterface> Sample_OpenBlackboardStream_Request_TypeSupportInterface_out;


            class Sample_OpenBlackboardStream_Request_DataWriter;

            typedef Sample_OpenBlackboardStream_Request_DataWriter * Sample_OpenBlackboardStream_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_OpenBlackboardStream_Request_DataWriter> Sample_OpenBlackboardStream_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_OpenBlackboardStream_Request_DataWriter> Sample_OpenBlackboardStream_Request_DataWriter_out;


            class Sample_OpenBlackboardStream_Request_DataReader;

            typedef Sample_OpenBlackboardStream_Request_DataReader * Sample_OpenBlackboardStream_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_OpenBlackboardStream_Request_DataReader> Sample_OpenBlackboardStream_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_OpenBlackboardStream_Request_DataReader> Sample_OpenBlackboardStream_Request_DataReader_out;


            class Sample_OpenBlackboardStream_Request_DataReaderView;

            typedef Sample_OpenBlackboardStream_Request_DataReaderView * Sample_OpenBlackboardStream_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_OpenBlackboardStream_Request_DataReaderView> Sample_OpenBlackboardStream_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_OpenBlackboardStream_Request_DataReaderView> Sample_OpenBlackboardStream_Request_DataReaderView_out;

            struct Sample_OpenBlackboardStream_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_OpenBlackboardStream_Request_, struct Sample_OpenBlackboardStream_Request_Seq_uniq_> Sample_OpenBlackboardStream_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_OpenBlackboardStream_Request_Seq> Sample_OpenBlackboardStream_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_OpenBlackboardStream_Request_Seq> Sample_OpenBlackboardStream_Request_Seq_out;

            class  Sample_OpenBlackboardStream_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_OpenBlackboardStream_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_OpenBlackboardStream_Request_TypeSupportInterface_var _var_type;

                static Sample_OpenBlackboardStream_Request_TypeSupportInterface_ptr _duplicate (Sample_OpenBlackboardStream_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_OpenBlackboardStream_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_OpenBlackboardStream_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_OpenBlackboardStream_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_OpenBlackboardStream_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_OpenBlackboardStream_Request_TypeSupportInterface () {};
                ~Sample_OpenBlackboardStream_Request_TypeSupportInterface () {};
            private:
                Sample_OpenBlackboardStream_Request_TypeSupportInterface (const Sample_OpenBlackboardStream_Request_TypeSupportInterface &);
                Sample_OpenBlackboardStream_Request_TypeSupportInterface & operator = (const Sample_OpenBlackboardStream_Request_TypeSupportInterface &);
            };

            class  Sample_OpenBlackboardStream_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_OpenBlackboardStream_Request_DataWriter_ptr _ptr_type;
                typedef Sample_OpenBlackboardStream_Request_DataWriter_var _var_type;

                static Sample_OpenBlackboardStream_Request_DataWriter_ptr _duplicate (Sample_OpenBlackboardStream_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_OpenBlackboardStream_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_OpenBlackboardStream_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_OpenBlackboardStream_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_OpenBlackboardStream_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_OpenBlackboardStream_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_OpenBlackboardStream_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_OpenBlackboardStream_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_OpenBlackboardStream_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_OpenBlackboardStream_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_OpenBlackboardStream_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_OpenBlackboardStream_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_OpenBlackboardStream_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_OpenBlackboardStream_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_OpenBlackboardStream_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_OpenBlackboardStream_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_OpenBlackboardStream_Request_& instance_data) = 0;

            protected:
                Sample_OpenBlackboardStream_Request_DataWriter () {};
                ~Sample_OpenBlackboardStream_Request_DataWriter () {};
            private:
                Sample_OpenBlackboardStream_Request_DataWriter (const Sample_OpenBlackboardStream_Request_DataWriter &);
                Sample_OpenBlackboardStream_Request_DataWriter & operator = (const Sample_OpenBlackboardStream_Request_DataWriter &);
            };

            class  Sample_OpenBlackboardStream_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_OpenBlackboardStream_Request_DataReader_ptr _ptr_type;
                typedef Sample_OpenBlackboardStream_Request_DataReader_var _var_type;

                static Sample_OpenBlackboardStream_Request_DataReader_ptr _duplicate (Sample_OpenBlackboardStream_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_OpenBlackboardStream_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_OpenBlackboardStream_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_OpenBlackboardStream_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_OpenBlackboardStream_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_OpenBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_OpenBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_OpenBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_OpenBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_OpenBlackboardStream_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_OpenBlackboardStream_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_OpenBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_OpenBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_OpenBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_OpenBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_OpenBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_OpenBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_OpenBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_OpenBlackboardStream_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_OpenBlackboardStream_Request_& instance) = 0;

            protected:
                Sample_OpenBlackboardStream_Request_DataReader () {};
                ~Sample_OpenBlackboardStream_Request_DataReader () {};
            private:
                Sample_OpenBlackboardStream_Request_DataReader (const Sample_OpenBlackboardStream_Request_DataReader &);
                Sample_OpenBlackboardStream_Request_DataReader & operator = (const Sample_OpenBlackboardStream_Request_DataReader &);
            };

            class  Sample_OpenBlackboardStream_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_OpenBlackboardStream_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_OpenBlackboardStream_Request_DataReaderView_var _var_type;

                static Sample_OpenBlackboardStream_Request_DataReaderView_ptr _duplicate (Sample_OpenBlackboardStream_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_OpenBlackboardStream_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_OpenBlackboardStream_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_OpenBlackboardStream_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_OpenBlackboardStream_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_OpenBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_OpenBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_OpenBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_OpenBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_OpenBlackboardStream_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_OpenBlackboardStream_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_OpenBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_OpenBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_OpenBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_OpenBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_OpenBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_OpenBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_OpenBlackboardStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_OpenBlackboardStream_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_OpenBlackboardStream_Request_& instance) = 0;

            protected:
                Sample_OpenBlackboardStream_Request_DataReaderView () {};
                ~Sample_OpenBlackboardStream_Request_DataReaderView () {};
            private:
                Sample_OpenBlackboardStream_Request_DataReaderView (const Sample_OpenBlackboardStream_Request_DataReaderView &);
                Sample_OpenBlackboardStream_Request_DataReaderView & operator = (const Sample_OpenBlackboardStream_Request_DataReaderView &);
            };
            class Sample_OpenBlackboardStream_Response_TypeSupportInterface;

            typedef Sample_OpenBlackboardStream_Response_TypeSupportInterface * Sample_OpenBlackboardStream_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_OpenBlackboardStream_Response_TypeSupportInterface> Sample_OpenBlackboardStream_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_OpenBlackboardStream_Response_TypeSupportInterface> Sample_OpenBlackboardStream_Response_TypeSupportInterface_out;


            class Sample_OpenBlackboardStream_Response_DataWriter;

            typedef Sample_OpenBlackboardStream_Response_DataWriter * Sample_OpenBlackboardStream_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_OpenBlackboardStream_Response_DataWriter> Sample_OpenBlackboardStream_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_OpenBlackboardStream_Response_DataWriter> Sample_OpenBlackboardStream_Response_DataWriter_out;


            class Sample_OpenBlackboardStream_Response_DataReader;

            typedef Sample_OpenBlackboardStream_Response_DataReader * Sample_OpenBlackboardStream_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_OpenBlackboardStream_Response_DataReader> Sample_OpenBlackboardStream_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_OpenBlackboardStream_Response_DataReader> Sample_OpenBlackboardStream_Response_DataReader_out;


            class Sample_OpenBlackboardStream_Response_DataReaderView;

            typedef Sample_OpenBlackboardStream_Response_DataReaderView * Sample_OpenBlackboardStream_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_OpenBlackboardStream_Response_DataReaderView> Sample_OpenBlackboardStream_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_OpenBlackboardStream_Response_DataReaderView> Sample_OpenBlackboardStream_Response_DataReaderView_out;

            struct Sample_OpenBlackboardStream_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_OpenBlackboardStream_Response_, struct Sample_OpenBlackboardStream_Response_Seq_uniq_> Sample_OpenBlackboardStream_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_OpenBlackboardStream_Response_Seq> Sample_OpenBlackboardStream_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_OpenBlackboardStream_Response_Seq> Sample_OpenBlackboardStream_Response_Seq_out;

            class  Sample_OpenBlackboardStream_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_OpenBlackboardStream_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_OpenBlackboardStream_Response_TypeSupportInterface_var _var_type;

                static Sample_OpenBlackboardStream_Response_TypeSupportInterface_ptr _duplicate (Sample_OpenBlackboardStream_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_OpenBlackboardStream_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_OpenBlackboardStream_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_OpenBlackboardStream_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_OpenBlackboardStream_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_OpenBlackboardStream_Response_TypeSupportInterface () {};
                ~Sample_OpenBlackboardStream_Response_TypeSupportInterface () {};
            private:
                Sample_OpenBlackboardStream_Response_TypeSupportInterface (const Sample_OpenBlackboardStream_Response_TypeSupportInterface &);
                Sample_OpenBlackboardStream_Response_TypeSupportInterface & operator = (const Sample_OpenBlackboardStream_Response_TypeSupportInterface &);
            };

            class  Sample_OpenBlackboardStream_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_OpenBlackboardStream_Response_DataWriter_ptr _ptr_type;
                typedef Sample_OpenBlackboardStream_Response_DataWriter_var _var_type;

                static Sample_OpenBlackboardStream_Response_DataWriter_ptr _duplicate (Sample_OpenBlackboardStream_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_OpenBlackboardStream_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_OpenBlackboardStream_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_OpenBlackboardStream_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_OpenBlackboardStream_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_OpenBlackboardStream_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_OpenBlackboardStream_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_OpenBlackboardStream_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_OpenBlackboardStream_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_OpenBlackboardStream_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_OpenBlackboardStream_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_OpenBlackboardStream_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_OpenBlackboardStream_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_OpenBlackboardStream_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_OpenBlackboardStream_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_OpenBlackboardStream_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_OpenBlackboardStream_Response_& instance_data) = 0;

            protected:
                Sample_OpenBlackboardStream_Response_DataWriter () {};
                ~Sample_OpenBlackboardStream_Response_DataWriter () {};
            private:
                Sample_OpenBlackboardStream_Response_DataWriter (const Sample_OpenBlackboardStream_Response_DataWriter &);
                Sample_OpenBlackboardStream_Response_DataWriter & operator = (const Sample_OpenBlackboardStream_Response_DataWriter &);
            };

            class  Sample_OpenBlackboardStream_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_OpenBlackboardStream_Response_DataReader_ptr _ptr_type;
                typedef Sample_OpenBlackboardStream_Response_DataReader_var _var_type;

                static Sample_OpenBlackboardStream_Response_DataReader_ptr _duplicate (Sample_OpenBlackboardStream_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_OpenBlackboardStream_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_OpenBlackboardStream_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_OpenBlackboardStream_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_OpenBlackboardStream_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_OpenBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_OpenBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_OpenBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_OpenBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_OpenBlackboardStream_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_OpenBlackboardStream_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_OpenBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_OpenBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_OpenBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_OpenBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_OpenBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_OpenBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_OpenBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_OpenBlackboardStream_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_OpenBlackboardStream_Response_& instance) = 0;

            protected:
                Sample_OpenBlackboardStream_Response_DataReader () {};
                ~Sample_OpenBlackboardStream_Response_DataReader () {};
            private:
                Sample_OpenBlackboardStream_Response_DataReader (const Sample_OpenBlackboardStream_Response_DataReader &);
                Sample_OpenBlackboardStream_Response_DataReader & operator = (const Sample_OpenBlackboardStream_Response_DataReader &);
            };

            class  Sample_OpenBlackboardStream_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_OpenBlackboardStream_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_OpenBlackboardStream_Response_DataReaderView_var _var_type;

                static Sample_OpenBlackboardStream_Response_DataReaderView_ptr _duplicate (Sample_OpenBlackboardStream_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_OpenBlackboardStream_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_OpenBlackboardStream_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_OpenBlackboardStream_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_OpenBlackboardStream_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_OpenBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_OpenBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_OpenBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_OpenBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_OpenBlackboardStream_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_OpenBlackboardStream_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_OpenBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_OpenBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_OpenBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_OpenBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_OpenBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_OpenBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_OpenBlackboardStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_OpenBlackboardStream_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_OpenBlackboardStream_Response_& instance) = 0;

            protected:
                Sample_OpenBlackboardStream_Response_DataReaderView () {};
                ~Sample_OpenBlackboardStream_Response_DataReaderView () {};
            private:
                Sample_OpenBlackboardStream_Response_DataReaderView (const Sample_OpenBlackboardStream_Response_DataReaderView &);
                Sample_OpenBlackboardStream_Response_DataReaderView & operator = (const Sample_OpenBlackboardStream_Response_DataReaderView &);
            };
        }

    }

}

#endif
