#ifndef _H_B06EA6AC955DBDB7EB0FC6050726DF68_OpenSnapshotStream__H_
#define _H_B06EA6AC955DBDB7EB0FC6050726DF68_OpenSnapshotStream__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "py_trees_ros_interfaces/msg/dds_opensplice/SnapshotStreamParameters_.h"


namespace py_trees_ros_interfaces
{
    namespace srv
    {
        namespace dds_
        {
            struct  OpenSnapshotStream_Request_
            {
                ::DDS::String_mgr topic_name_;
                ::py_trees_ros_interfaces::msg::dds_::SnapshotStreamParameters_ parameters_;
            };

            typedef DDS_DCPSStruct_var<OpenSnapshotStream_Request_> OpenSnapshotStream_Request__var;
            typedef DDS_DCPSStruct_out < OpenSnapshotStream_Request_> OpenSnapshotStream_Request__out;

            struct  OpenSnapshotStream_Response_
            {
                ::DDS::String_mgr topic_name_;
            };

            typedef DDS_DCPSStruct_var<OpenSnapshotStream_Response_> OpenSnapshotStream_Response__var;
            typedef DDS_DCPSStruct_out < OpenSnapshotStream_Response_> OpenSnapshotStream_Response__out;

            struct  Sample_OpenSnapshotStream_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::py_trees_ros_interfaces::srv::dds_::OpenSnapshotStream_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_OpenSnapshotStream_Request_> Sample_OpenSnapshotStream_Request__var;
            typedef DDS_DCPSStruct_out < Sample_OpenSnapshotStream_Request_> Sample_OpenSnapshotStream_Request__out;

            struct  Sample_OpenSnapshotStream_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::py_trees_ros_interfaces::srv::dds_::OpenSnapshotStream_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_OpenSnapshotStream_Response_> Sample_OpenSnapshotStream_Response__var;
            typedef DDS_DCPSStruct_out < Sample_OpenSnapshotStream_Response_> Sample_OpenSnapshotStream_Response__out;

        }

    }

}

#endif /* _H_B06EA6AC955DBDB7EB0FC6050726DF68_OpenSnapshotStream__H_ */
