#ifndef _H_B06EA6AC955DBDB7EB0FC6050726DF68_OpenSnapshotStream_DCPS_H_
#define _H_B06EA6AC955DBDB7EB0FC6050726DF68_OpenSnapshotStream_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "OpenSnapshotStream_.h"


namespace py_trees_ros_interfaces
{
    namespace srv
    {
        namespace dds_
        {
            class OpenSnapshotStream_Request_TypeSupportInterface;

            typedef OpenSnapshotStream_Request_TypeSupportInterface * OpenSnapshotStream_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < OpenSnapshotStream_Request_TypeSupportInterface> OpenSnapshotStream_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < OpenSnapshotStream_Request_TypeSupportInterface> OpenSnapshotStream_Request_TypeSupportInterface_out;


            class OpenSnapshotStream_Request_DataWriter;

            typedef OpenSnapshotStream_Request_DataWriter * OpenSnapshotStream_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < OpenSnapshotStream_Request_DataWriter> OpenSnapshotStream_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < OpenSnapshotStream_Request_DataWriter> OpenSnapshotStream_Request_DataWriter_out;


            class OpenSnapshotStream_Request_DataReader;

            typedef OpenSnapshotStream_Request_DataReader * OpenSnapshotStream_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < OpenSnapshotStream_Request_DataReader> OpenSnapshotStream_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < OpenSnapshotStream_Request_DataReader> OpenSnapshotStream_Request_DataReader_out;


            class OpenSnapshotStream_Request_DataReaderView;

            typedef OpenSnapshotStream_Request_DataReaderView * OpenSnapshotStream_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < OpenSnapshotStream_Request_DataReaderView> OpenSnapshotStream_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < OpenSnapshotStream_Request_DataReaderView> OpenSnapshotStream_Request_DataReaderView_out;

            struct OpenSnapshotStream_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < OpenSnapshotStream_Request_, struct OpenSnapshotStream_Request_Seq_uniq_> OpenSnapshotStream_Request_Seq;
            typedef DDS_DCPSSequence_var < OpenSnapshotStream_Request_Seq> OpenSnapshotStream_Request_Seq_var;
            typedef DDS_DCPSSequence_out < OpenSnapshotStream_Request_Seq> OpenSnapshotStream_Request_Seq_out;

            class  OpenSnapshotStream_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef OpenSnapshotStream_Request_TypeSupportInterface_ptr _ptr_type;
                typedef OpenSnapshotStream_Request_TypeSupportInterface_var _var_type;

                static OpenSnapshotStream_Request_TypeSupportInterface_ptr _duplicate (OpenSnapshotStream_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static OpenSnapshotStream_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static OpenSnapshotStream_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static OpenSnapshotStream_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                OpenSnapshotStream_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                OpenSnapshotStream_Request_TypeSupportInterface () {};
                ~OpenSnapshotStream_Request_TypeSupportInterface () {};
            private:
                OpenSnapshotStream_Request_TypeSupportInterface (const OpenSnapshotStream_Request_TypeSupportInterface &);
                OpenSnapshotStream_Request_TypeSupportInterface & operator = (const OpenSnapshotStream_Request_TypeSupportInterface &);
            };

            class  OpenSnapshotStream_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef OpenSnapshotStream_Request_DataWriter_ptr _ptr_type;
                typedef OpenSnapshotStream_Request_DataWriter_var _var_type;

                static OpenSnapshotStream_Request_DataWriter_ptr _duplicate (OpenSnapshotStream_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static OpenSnapshotStream_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static OpenSnapshotStream_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static OpenSnapshotStream_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                OpenSnapshotStream_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const OpenSnapshotStream_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const OpenSnapshotStream_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const OpenSnapshotStream_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const OpenSnapshotStream_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const OpenSnapshotStream_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const OpenSnapshotStream_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const OpenSnapshotStream_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const OpenSnapshotStream_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const OpenSnapshotStream_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const OpenSnapshotStream_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (OpenSnapshotStream_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const OpenSnapshotStream_Request_& instance_data) = 0;

            protected:
                OpenSnapshotStream_Request_DataWriter () {};
                ~OpenSnapshotStream_Request_DataWriter () {};
            private:
                OpenSnapshotStream_Request_DataWriter (const OpenSnapshotStream_Request_DataWriter &);
                OpenSnapshotStream_Request_DataWriter & operator = (const OpenSnapshotStream_Request_DataWriter &);
            };

            class  OpenSnapshotStream_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef OpenSnapshotStream_Request_DataReader_ptr _ptr_type;
                typedef OpenSnapshotStream_Request_DataReader_var _var_type;

                static OpenSnapshotStream_Request_DataReader_ptr _duplicate (OpenSnapshotStream_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static OpenSnapshotStream_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static OpenSnapshotStream_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static OpenSnapshotStream_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                OpenSnapshotStream_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (OpenSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (OpenSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (OpenSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (OpenSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (OpenSnapshotStream_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (OpenSnapshotStream_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (OpenSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (OpenSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (OpenSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (OpenSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (OpenSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (OpenSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (OpenSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (OpenSnapshotStream_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const OpenSnapshotStream_Request_& instance) = 0;

            protected:
                OpenSnapshotStream_Request_DataReader () {};
                ~OpenSnapshotStream_Request_DataReader () {};
            private:
                OpenSnapshotStream_Request_DataReader (const OpenSnapshotStream_Request_DataReader &);
                OpenSnapshotStream_Request_DataReader & operator = (const OpenSnapshotStream_Request_DataReader &);
            };

            class  OpenSnapshotStream_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef OpenSnapshotStream_Request_DataReaderView_ptr _ptr_type;
                typedef OpenSnapshotStream_Request_DataReaderView_var _var_type;

                static OpenSnapshotStream_Request_DataReaderView_ptr _duplicate (OpenSnapshotStream_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static OpenSnapshotStream_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static OpenSnapshotStream_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static OpenSnapshotStream_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                OpenSnapshotStream_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (OpenSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (OpenSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (OpenSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (OpenSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (OpenSnapshotStream_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (OpenSnapshotStream_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (OpenSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (OpenSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (OpenSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (OpenSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (OpenSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (OpenSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (OpenSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (OpenSnapshotStream_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const OpenSnapshotStream_Request_& instance) = 0;

            protected:
                OpenSnapshotStream_Request_DataReaderView () {};
                ~OpenSnapshotStream_Request_DataReaderView () {};
            private:
                OpenSnapshotStream_Request_DataReaderView (const OpenSnapshotStream_Request_DataReaderView &);
                OpenSnapshotStream_Request_DataReaderView & operator = (const OpenSnapshotStream_Request_DataReaderView &);
            };
            class OpenSnapshotStream_Response_TypeSupportInterface;

            typedef OpenSnapshotStream_Response_TypeSupportInterface * OpenSnapshotStream_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < OpenSnapshotStream_Response_TypeSupportInterface> OpenSnapshotStream_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < OpenSnapshotStream_Response_TypeSupportInterface> OpenSnapshotStream_Response_TypeSupportInterface_out;


            class OpenSnapshotStream_Response_DataWriter;

            typedef OpenSnapshotStream_Response_DataWriter * OpenSnapshotStream_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < OpenSnapshotStream_Response_DataWriter> OpenSnapshotStream_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < OpenSnapshotStream_Response_DataWriter> OpenSnapshotStream_Response_DataWriter_out;


            class OpenSnapshotStream_Response_DataReader;

            typedef OpenSnapshotStream_Response_DataReader * OpenSnapshotStream_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < OpenSnapshotStream_Response_DataReader> OpenSnapshotStream_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < OpenSnapshotStream_Response_DataReader> OpenSnapshotStream_Response_DataReader_out;


            class OpenSnapshotStream_Response_DataReaderView;

            typedef OpenSnapshotStream_Response_DataReaderView * OpenSnapshotStream_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < OpenSnapshotStream_Response_DataReaderView> OpenSnapshotStream_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < OpenSnapshotStream_Response_DataReaderView> OpenSnapshotStream_Response_DataReaderView_out;

            struct OpenSnapshotStream_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < OpenSnapshotStream_Response_, struct OpenSnapshotStream_Response_Seq_uniq_> OpenSnapshotStream_Response_Seq;
            typedef DDS_DCPSSequence_var < OpenSnapshotStream_Response_Seq> OpenSnapshotStream_Response_Seq_var;
            typedef DDS_DCPSSequence_out < OpenSnapshotStream_Response_Seq> OpenSnapshotStream_Response_Seq_out;

            class  OpenSnapshotStream_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef OpenSnapshotStream_Response_TypeSupportInterface_ptr _ptr_type;
                typedef OpenSnapshotStream_Response_TypeSupportInterface_var _var_type;

                static OpenSnapshotStream_Response_TypeSupportInterface_ptr _duplicate (OpenSnapshotStream_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static OpenSnapshotStream_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static OpenSnapshotStream_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static OpenSnapshotStream_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                OpenSnapshotStream_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                OpenSnapshotStream_Response_TypeSupportInterface () {};
                ~OpenSnapshotStream_Response_TypeSupportInterface () {};
            private:
                OpenSnapshotStream_Response_TypeSupportInterface (const OpenSnapshotStream_Response_TypeSupportInterface &);
                OpenSnapshotStream_Response_TypeSupportInterface & operator = (const OpenSnapshotStream_Response_TypeSupportInterface &);
            };

            class  OpenSnapshotStream_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef OpenSnapshotStream_Response_DataWriter_ptr _ptr_type;
                typedef OpenSnapshotStream_Response_DataWriter_var _var_type;

                static OpenSnapshotStream_Response_DataWriter_ptr _duplicate (OpenSnapshotStream_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static OpenSnapshotStream_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static OpenSnapshotStream_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static OpenSnapshotStream_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                OpenSnapshotStream_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const OpenSnapshotStream_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const OpenSnapshotStream_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const OpenSnapshotStream_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const OpenSnapshotStream_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const OpenSnapshotStream_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const OpenSnapshotStream_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const OpenSnapshotStream_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const OpenSnapshotStream_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const OpenSnapshotStream_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const OpenSnapshotStream_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (OpenSnapshotStream_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const OpenSnapshotStream_Response_& instance_data) = 0;

            protected:
                OpenSnapshotStream_Response_DataWriter () {};
                ~OpenSnapshotStream_Response_DataWriter () {};
            private:
                OpenSnapshotStream_Response_DataWriter (const OpenSnapshotStream_Response_DataWriter &);
                OpenSnapshotStream_Response_DataWriter & operator = (const OpenSnapshotStream_Response_DataWriter &);
            };

            class  OpenSnapshotStream_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef OpenSnapshotStream_Response_DataReader_ptr _ptr_type;
                typedef OpenSnapshotStream_Response_DataReader_var _var_type;

                static OpenSnapshotStream_Response_DataReader_ptr _duplicate (OpenSnapshotStream_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static OpenSnapshotStream_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static OpenSnapshotStream_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static OpenSnapshotStream_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                OpenSnapshotStream_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (OpenSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (OpenSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (OpenSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (OpenSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (OpenSnapshotStream_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (OpenSnapshotStream_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (OpenSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (OpenSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (OpenSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (OpenSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (OpenSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (OpenSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (OpenSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (OpenSnapshotStream_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const OpenSnapshotStream_Response_& instance) = 0;

            protected:
                OpenSnapshotStream_Response_DataReader () {};
                ~OpenSnapshotStream_Response_DataReader () {};
            private:
                OpenSnapshotStream_Response_DataReader (const OpenSnapshotStream_Response_DataReader &);
                OpenSnapshotStream_Response_DataReader & operator = (const OpenSnapshotStream_Response_DataReader &);
            };

            class  OpenSnapshotStream_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef OpenSnapshotStream_Response_DataReaderView_ptr _ptr_type;
                typedef OpenSnapshotStream_Response_DataReaderView_var _var_type;

                static OpenSnapshotStream_Response_DataReaderView_ptr _duplicate (OpenSnapshotStream_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static OpenSnapshotStream_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static OpenSnapshotStream_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static OpenSnapshotStream_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                OpenSnapshotStream_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (OpenSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (OpenSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (OpenSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (OpenSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (OpenSnapshotStream_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (OpenSnapshotStream_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (OpenSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (OpenSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (OpenSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (OpenSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (OpenSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (OpenSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (OpenSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (OpenSnapshotStream_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const OpenSnapshotStream_Response_& instance) = 0;

            protected:
                OpenSnapshotStream_Response_DataReaderView () {};
                ~OpenSnapshotStream_Response_DataReaderView () {};
            private:
                OpenSnapshotStream_Response_DataReaderView (const OpenSnapshotStream_Response_DataReaderView &);
                OpenSnapshotStream_Response_DataReaderView & operator = (const OpenSnapshotStream_Response_DataReaderView &);
            };
            class Sample_OpenSnapshotStream_Request_TypeSupportInterface;

            typedef Sample_OpenSnapshotStream_Request_TypeSupportInterface * Sample_OpenSnapshotStream_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_OpenSnapshotStream_Request_TypeSupportInterface> Sample_OpenSnapshotStream_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_OpenSnapshotStream_Request_TypeSupportInterface> Sample_OpenSnapshotStream_Request_TypeSupportInterface_out;


            class Sample_OpenSnapshotStream_Request_DataWriter;

            typedef Sample_OpenSnapshotStream_Request_DataWriter * Sample_OpenSnapshotStream_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_OpenSnapshotStream_Request_DataWriter> Sample_OpenSnapshotStream_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_OpenSnapshotStream_Request_DataWriter> Sample_OpenSnapshotStream_Request_DataWriter_out;


            class Sample_OpenSnapshotStream_Request_DataReader;

            typedef Sample_OpenSnapshotStream_Request_DataReader * Sample_OpenSnapshotStream_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_OpenSnapshotStream_Request_DataReader> Sample_OpenSnapshotStream_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_OpenSnapshotStream_Request_DataReader> Sample_OpenSnapshotStream_Request_DataReader_out;


            class Sample_OpenSnapshotStream_Request_DataReaderView;

            typedef Sample_OpenSnapshotStream_Request_DataReaderView * Sample_OpenSnapshotStream_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_OpenSnapshotStream_Request_DataReaderView> Sample_OpenSnapshotStream_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_OpenSnapshotStream_Request_DataReaderView> Sample_OpenSnapshotStream_Request_DataReaderView_out;

            struct Sample_OpenSnapshotStream_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_OpenSnapshotStream_Request_, struct Sample_OpenSnapshotStream_Request_Seq_uniq_> Sample_OpenSnapshotStream_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_OpenSnapshotStream_Request_Seq> Sample_OpenSnapshotStream_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_OpenSnapshotStream_Request_Seq> Sample_OpenSnapshotStream_Request_Seq_out;

            class  Sample_OpenSnapshotStream_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_OpenSnapshotStream_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_OpenSnapshotStream_Request_TypeSupportInterface_var _var_type;

                static Sample_OpenSnapshotStream_Request_TypeSupportInterface_ptr _duplicate (Sample_OpenSnapshotStream_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_OpenSnapshotStream_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_OpenSnapshotStream_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_OpenSnapshotStream_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_OpenSnapshotStream_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_OpenSnapshotStream_Request_TypeSupportInterface () {};
                ~Sample_OpenSnapshotStream_Request_TypeSupportInterface () {};
            private:
                Sample_OpenSnapshotStream_Request_TypeSupportInterface (const Sample_OpenSnapshotStream_Request_TypeSupportInterface &);
                Sample_OpenSnapshotStream_Request_TypeSupportInterface & operator = (const Sample_OpenSnapshotStream_Request_TypeSupportInterface &);
            };

            class  Sample_OpenSnapshotStream_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_OpenSnapshotStream_Request_DataWriter_ptr _ptr_type;
                typedef Sample_OpenSnapshotStream_Request_DataWriter_var _var_type;

                static Sample_OpenSnapshotStream_Request_DataWriter_ptr _duplicate (Sample_OpenSnapshotStream_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_OpenSnapshotStream_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_OpenSnapshotStream_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_OpenSnapshotStream_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_OpenSnapshotStream_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_OpenSnapshotStream_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_OpenSnapshotStream_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_OpenSnapshotStream_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_OpenSnapshotStream_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_OpenSnapshotStream_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_OpenSnapshotStream_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_OpenSnapshotStream_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_OpenSnapshotStream_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_OpenSnapshotStream_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_OpenSnapshotStream_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_OpenSnapshotStream_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_OpenSnapshotStream_Request_& instance_data) = 0;

            protected:
                Sample_OpenSnapshotStream_Request_DataWriter () {};
                ~Sample_OpenSnapshotStream_Request_DataWriter () {};
            private:
                Sample_OpenSnapshotStream_Request_DataWriter (const Sample_OpenSnapshotStream_Request_DataWriter &);
                Sample_OpenSnapshotStream_Request_DataWriter & operator = (const Sample_OpenSnapshotStream_Request_DataWriter &);
            };

            class  Sample_OpenSnapshotStream_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_OpenSnapshotStream_Request_DataReader_ptr _ptr_type;
                typedef Sample_OpenSnapshotStream_Request_DataReader_var _var_type;

                static Sample_OpenSnapshotStream_Request_DataReader_ptr _duplicate (Sample_OpenSnapshotStream_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_OpenSnapshotStream_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_OpenSnapshotStream_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_OpenSnapshotStream_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_OpenSnapshotStream_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_OpenSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_OpenSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_OpenSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_OpenSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_OpenSnapshotStream_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_OpenSnapshotStream_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_OpenSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_OpenSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_OpenSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_OpenSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_OpenSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_OpenSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_OpenSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_OpenSnapshotStream_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_OpenSnapshotStream_Request_& instance) = 0;

            protected:
                Sample_OpenSnapshotStream_Request_DataReader () {};
                ~Sample_OpenSnapshotStream_Request_DataReader () {};
            private:
                Sample_OpenSnapshotStream_Request_DataReader (const Sample_OpenSnapshotStream_Request_DataReader &);
                Sample_OpenSnapshotStream_Request_DataReader & operator = (const Sample_OpenSnapshotStream_Request_DataReader &);
            };

            class  Sample_OpenSnapshotStream_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_OpenSnapshotStream_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_OpenSnapshotStream_Request_DataReaderView_var _var_type;

                static Sample_OpenSnapshotStream_Request_DataReaderView_ptr _duplicate (Sample_OpenSnapshotStream_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_OpenSnapshotStream_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_OpenSnapshotStream_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_OpenSnapshotStream_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_OpenSnapshotStream_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_OpenSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_OpenSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_OpenSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_OpenSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_OpenSnapshotStream_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_OpenSnapshotStream_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_OpenSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_OpenSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_OpenSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_OpenSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_OpenSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_OpenSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_OpenSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_OpenSnapshotStream_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_OpenSnapshotStream_Request_& instance) = 0;

            protected:
                Sample_OpenSnapshotStream_Request_DataReaderView () {};
                ~Sample_OpenSnapshotStream_Request_DataReaderView () {};
            private:
                Sample_OpenSnapshotStream_Request_DataReaderView (const Sample_OpenSnapshotStream_Request_DataReaderView &);
                Sample_OpenSnapshotStream_Request_DataReaderView & operator = (const Sample_OpenSnapshotStream_Request_DataReaderView &);
            };
            class Sample_OpenSnapshotStream_Response_TypeSupportInterface;

            typedef Sample_OpenSnapshotStream_Response_TypeSupportInterface * Sample_OpenSnapshotStream_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_OpenSnapshotStream_Response_TypeSupportInterface> Sample_OpenSnapshotStream_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_OpenSnapshotStream_Response_TypeSupportInterface> Sample_OpenSnapshotStream_Response_TypeSupportInterface_out;


            class Sample_OpenSnapshotStream_Response_DataWriter;

            typedef Sample_OpenSnapshotStream_Response_DataWriter * Sample_OpenSnapshotStream_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_OpenSnapshotStream_Response_DataWriter> Sample_OpenSnapshotStream_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_OpenSnapshotStream_Response_DataWriter> Sample_OpenSnapshotStream_Response_DataWriter_out;


            class Sample_OpenSnapshotStream_Response_DataReader;

            typedef Sample_OpenSnapshotStream_Response_DataReader * Sample_OpenSnapshotStream_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_OpenSnapshotStream_Response_DataReader> Sample_OpenSnapshotStream_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_OpenSnapshotStream_Response_DataReader> Sample_OpenSnapshotStream_Response_DataReader_out;


            class Sample_OpenSnapshotStream_Response_DataReaderView;

            typedef Sample_OpenSnapshotStream_Response_DataReaderView * Sample_OpenSnapshotStream_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_OpenSnapshotStream_Response_DataReaderView> Sample_OpenSnapshotStream_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_OpenSnapshotStream_Response_DataReaderView> Sample_OpenSnapshotStream_Response_DataReaderView_out;

            struct Sample_OpenSnapshotStream_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_OpenSnapshotStream_Response_, struct Sample_OpenSnapshotStream_Response_Seq_uniq_> Sample_OpenSnapshotStream_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_OpenSnapshotStream_Response_Seq> Sample_OpenSnapshotStream_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_OpenSnapshotStream_Response_Seq> Sample_OpenSnapshotStream_Response_Seq_out;

            class  Sample_OpenSnapshotStream_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_OpenSnapshotStream_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_OpenSnapshotStream_Response_TypeSupportInterface_var _var_type;

                static Sample_OpenSnapshotStream_Response_TypeSupportInterface_ptr _duplicate (Sample_OpenSnapshotStream_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_OpenSnapshotStream_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_OpenSnapshotStream_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_OpenSnapshotStream_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_OpenSnapshotStream_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_OpenSnapshotStream_Response_TypeSupportInterface () {};
                ~Sample_OpenSnapshotStream_Response_TypeSupportInterface () {};
            private:
                Sample_OpenSnapshotStream_Response_TypeSupportInterface (const Sample_OpenSnapshotStream_Response_TypeSupportInterface &);
                Sample_OpenSnapshotStream_Response_TypeSupportInterface & operator = (const Sample_OpenSnapshotStream_Response_TypeSupportInterface &);
            };

            class  Sample_OpenSnapshotStream_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_OpenSnapshotStream_Response_DataWriter_ptr _ptr_type;
                typedef Sample_OpenSnapshotStream_Response_DataWriter_var _var_type;

                static Sample_OpenSnapshotStream_Response_DataWriter_ptr _duplicate (Sample_OpenSnapshotStream_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_OpenSnapshotStream_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_OpenSnapshotStream_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_OpenSnapshotStream_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_OpenSnapshotStream_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_OpenSnapshotStream_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_OpenSnapshotStream_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_OpenSnapshotStream_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_OpenSnapshotStream_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_OpenSnapshotStream_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_OpenSnapshotStream_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_OpenSnapshotStream_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_OpenSnapshotStream_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_OpenSnapshotStream_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_OpenSnapshotStream_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_OpenSnapshotStream_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_OpenSnapshotStream_Response_& instance_data) = 0;

            protected:
                Sample_OpenSnapshotStream_Response_DataWriter () {};
                ~Sample_OpenSnapshotStream_Response_DataWriter () {};
            private:
                Sample_OpenSnapshotStream_Response_DataWriter (const Sample_OpenSnapshotStream_Response_DataWriter &);
                Sample_OpenSnapshotStream_Response_DataWriter & operator = (const Sample_OpenSnapshotStream_Response_DataWriter &);
            };

            class  Sample_OpenSnapshotStream_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_OpenSnapshotStream_Response_DataReader_ptr _ptr_type;
                typedef Sample_OpenSnapshotStream_Response_DataReader_var _var_type;

                static Sample_OpenSnapshotStream_Response_DataReader_ptr _duplicate (Sample_OpenSnapshotStream_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_OpenSnapshotStream_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_OpenSnapshotStream_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_OpenSnapshotStream_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_OpenSnapshotStream_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_OpenSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_OpenSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_OpenSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_OpenSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_OpenSnapshotStream_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_OpenSnapshotStream_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_OpenSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_OpenSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_OpenSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_OpenSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_OpenSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_OpenSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_OpenSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_OpenSnapshotStream_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_OpenSnapshotStream_Response_& instance) = 0;

            protected:
                Sample_OpenSnapshotStream_Response_DataReader () {};
                ~Sample_OpenSnapshotStream_Response_DataReader () {};
            private:
                Sample_OpenSnapshotStream_Response_DataReader (const Sample_OpenSnapshotStream_Response_DataReader &);
                Sample_OpenSnapshotStream_Response_DataReader & operator = (const Sample_OpenSnapshotStream_Response_DataReader &);
            };

            class  Sample_OpenSnapshotStream_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_OpenSnapshotStream_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_OpenSnapshotStream_Response_DataReaderView_var _var_type;

                static Sample_OpenSnapshotStream_Response_DataReaderView_ptr _duplicate (Sample_OpenSnapshotStream_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_OpenSnapshotStream_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_OpenSnapshotStream_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_OpenSnapshotStream_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_OpenSnapshotStream_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_OpenSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_OpenSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_OpenSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_OpenSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_OpenSnapshotStream_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_OpenSnapshotStream_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_OpenSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_OpenSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_OpenSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_OpenSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_OpenSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_OpenSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_OpenSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_OpenSnapshotStream_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_OpenSnapshotStream_Response_& instance) = 0;

            protected:
                Sample_OpenSnapshotStream_Response_DataReaderView () {};
                ~Sample_OpenSnapshotStream_Response_DataReaderView () {};
            private:
                Sample_OpenSnapshotStream_Response_DataReaderView (const Sample_OpenSnapshotStream_Response_DataReaderView &);
                Sample_OpenSnapshotStream_Response_DataReaderView & operator = (const Sample_OpenSnapshotStream_Response_DataReaderView &);
            };
        }

    }

}

#endif
