#ifndef _H_72B88F621E522131EE43AE6EB6C40A05_ActivityItem_DCPS_H_
#define _H_72B88F621E522131EE43AE6EB6C40A05_ActivityItem_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ActivityItem_.h"


namespace py_trees_ros_interfaces
{
    namespace msg
    {
        namespace dds_
        {
            class ActivityItem_TypeSupportInterface;

            typedef ActivityItem_TypeSupportInterface * ActivityItem_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ActivityItem_TypeSupportInterface> ActivityItem_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ActivityItem_TypeSupportInterface> ActivityItem_TypeSupportInterface_out;


            class ActivityItem_DataWriter;

            typedef ActivityItem_DataWriter * ActivityItem_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ActivityItem_DataWriter> ActivityItem_DataWriter_var;
            typedef DDS_DCPSInterface_out < ActivityItem_DataWriter> ActivityItem_DataWriter_out;


            class ActivityItem_DataReader;

            typedef ActivityItem_DataReader * ActivityItem_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ActivityItem_DataReader> ActivityItem_DataReader_var;
            typedef DDS_DCPSInterface_out < ActivityItem_DataReader> ActivityItem_DataReader_out;


            class ActivityItem_DataReaderView;

            typedef ActivityItem_DataReaderView * ActivityItem_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ActivityItem_DataReaderView> ActivityItem_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ActivityItem_DataReaderView> ActivityItem_DataReaderView_out;

            struct ActivityItem_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ActivityItem_, struct ActivityItem_Seq_uniq_> ActivityItem_Seq;
            typedef DDS_DCPSSequence_var < ActivityItem_Seq> ActivityItem_Seq_var;
            typedef DDS_DCPSSequence_out < ActivityItem_Seq> ActivityItem_Seq_out;

            class  ActivityItem_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ActivityItem_TypeSupportInterface_ptr _ptr_type;
                typedef ActivityItem_TypeSupportInterface_var _var_type;

                static ActivityItem_TypeSupportInterface_ptr _duplicate (ActivityItem_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActivityItem_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ActivityItem_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActivityItem_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ActivityItem_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ActivityItem_TypeSupportInterface () {};
                ~ActivityItem_TypeSupportInterface () {};
            private:
                ActivityItem_TypeSupportInterface (const ActivityItem_TypeSupportInterface &);
                ActivityItem_TypeSupportInterface & operator = (const ActivityItem_TypeSupportInterface &);
            };

            class  ActivityItem_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ActivityItem_DataWriter_ptr _ptr_type;
                typedef ActivityItem_DataWriter_var _var_type;

                static ActivityItem_DataWriter_ptr _duplicate (ActivityItem_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActivityItem_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ActivityItem_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActivityItem_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ActivityItem_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ActivityItem_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ActivityItem_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ActivityItem_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ActivityItem_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ActivityItem_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ActivityItem_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ActivityItem_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ActivityItem_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ActivityItem_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ActivityItem_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ActivityItem_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ActivityItem_& instance_data) = 0;

            protected:
                ActivityItem_DataWriter () {};
                ~ActivityItem_DataWriter () {};
            private:
                ActivityItem_DataWriter (const ActivityItem_DataWriter &);
                ActivityItem_DataWriter & operator = (const ActivityItem_DataWriter &);
            };

            class  ActivityItem_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ActivityItem_DataReader_ptr _ptr_type;
                typedef ActivityItem_DataReader_var _var_type;

                static ActivityItem_DataReader_ptr _duplicate (ActivityItem_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActivityItem_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ActivityItem_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActivityItem_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ActivityItem_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ActivityItem_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ActivityItem_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ActivityItem_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ActivityItem_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ActivityItem_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ActivityItem_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ActivityItem_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ActivityItem_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ActivityItem_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ActivityItem_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ActivityItem_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ActivityItem_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ActivityItem_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ActivityItem_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ActivityItem_& instance) = 0;

            protected:
                ActivityItem_DataReader () {};
                ~ActivityItem_DataReader () {};
            private:
                ActivityItem_DataReader (const ActivityItem_DataReader &);
                ActivityItem_DataReader & operator = (const ActivityItem_DataReader &);
            };

            class  ActivityItem_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ActivityItem_DataReaderView_ptr _ptr_type;
                typedef ActivityItem_DataReaderView_var _var_type;

                static ActivityItem_DataReaderView_ptr _duplicate (ActivityItem_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActivityItem_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ActivityItem_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActivityItem_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ActivityItem_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ActivityItem_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ActivityItem_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ActivityItem_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ActivityItem_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ActivityItem_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ActivityItem_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ActivityItem_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ActivityItem_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ActivityItem_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ActivityItem_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ActivityItem_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ActivityItem_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ActivityItem_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ActivityItem_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ActivityItem_& instance) = 0;

            protected:
                ActivityItem_DataReaderView () {};
                ~ActivityItem_DataReaderView () {};
            private:
                ActivityItem_DataReaderView (const ActivityItem_DataReaderView &);
                ActivityItem_DataReaderView & operator = (const ActivityItem_DataReaderView &);
            };
        }

    }

}

#endif
