#ifndef _H_90E46570B9BD666C5BCC3A015A3F2BCA_CloseBlackboardStream__H_
#define _H_90E46570B9BD666C5BCC3A015A3F2BCA_CloseBlackboardStream__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace py_trees_ros_interfaces
{
    namespace srv
    {
        namespace dds_
        {
            struct  CloseBlackboardStream_Request_
            {
                ::DDS::String_mgr topic_name_;
            };

            typedef DDS_DCPSStruct_var<CloseBlackboardStream_Request_> CloseBlackboardStream_Request__var;
            typedef DDS_DCPSStruct_out < CloseBlackboardStream_Request_> CloseBlackboardStream_Request__out;

            struct  CloseBlackboardStream_Response_
            {
                ::DDS::Boolean result_;
            };

            typedef DDS_DCPSStruct_var<CloseBlackboardStream_Response_> CloseBlackboardStream_Response__var;
            typedef CloseBlackboardStream_Response_& CloseBlackboardStream_Response__out;

            struct  Sample_CloseBlackboardStream_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::py_trees_ros_interfaces::srv::dds_::CloseBlackboardStream_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_CloseBlackboardStream_Request_> Sample_CloseBlackboardStream_Request__var;
            typedef DDS_DCPSStruct_out < Sample_CloseBlackboardStream_Request_> Sample_CloseBlackboardStream_Request__out;

            struct  Sample_CloseBlackboardStream_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::py_trees_ros_interfaces::srv::dds_::CloseBlackboardStream_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_CloseBlackboardStream_Response_> Sample_CloseBlackboardStream_Response__var;
            typedef Sample_CloseBlackboardStream_Response_& Sample_CloseBlackboardStream_Response__out;

        }

    }

}

#endif /* _H_90E46570B9BD666C5BCC3A015A3F2BCA_CloseBlackboardStream__H_ */
