#ifndef _H_F00D6DFFBC303A9A317F21B135141F4E_CloseSnapshotStream_DCPS_H_
#define _H_F00D6DFFBC303A9A317F21B135141F4E_CloseSnapshotStream_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "CloseSnapshotStream_.h"


namespace py_trees_ros_interfaces
{
    namespace srv
    {
        namespace dds_
        {
            class CloseSnapshotStream_Request_TypeSupportInterface;

            typedef CloseSnapshotStream_Request_TypeSupportInterface * CloseSnapshotStream_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < CloseSnapshotStream_Request_TypeSupportInterface> CloseSnapshotStream_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < CloseSnapshotStream_Request_TypeSupportInterface> CloseSnapshotStream_Request_TypeSupportInterface_out;


            class CloseSnapshotStream_Request_DataWriter;

            typedef CloseSnapshotStream_Request_DataWriter * CloseSnapshotStream_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < CloseSnapshotStream_Request_DataWriter> CloseSnapshotStream_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < CloseSnapshotStream_Request_DataWriter> CloseSnapshotStream_Request_DataWriter_out;


            class CloseSnapshotStream_Request_DataReader;

            typedef CloseSnapshotStream_Request_DataReader * CloseSnapshotStream_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < CloseSnapshotStream_Request_DataReader> CloseSnapshotStream_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < CloseSnapshotStream_Request_DataReader> CloseSnapshotStream_Request_DataReader_out;


            class CloseSnapshotStream_Request_DataReaderView;

            typedef CloseSnapshotStream_Request_DataReaderView * CloseSnapshotStream_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < CloseSnapshotStream_Request_DataReaderView> CloseSnapshotStream_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < CloseSnapshotStream_Request_DataReaderView> CloseSnapshotStream_Request_DataReaderView_out;

            struct CloseSnapshotStream_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < CloseSnapshotStream_Request_, struct CloseSnapshotStream_Request_Seq_uniq_> CloseSnapshotStream_Request_Seq;
            typedef DDS_DCPSSequence_var < CloseSnapshotStream_Request_Seq> CloseSnapshotStream_Request_Seq_var;
            typedef DDS_DCPSSequence_out < CloseSnapshotStream_Request_Seq> CloseSnapshotStream_Request_Seq_out;

            class  CloseSnapshotStream_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef CloseSnapshotStream_Request_TypeSupportInterface_ptr _ptr_type;
                typedef CloseSnapshotStream_Request_TypeSupportInterface_var _var_type;

                static CloseSnapshotStream_Request_TypeSupportInterface_ptr _duplicate (CloseSnapshotStream_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CloseSnapshotStream_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static CloseSnapshotStream_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CloseSnapshotStream_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                CloseSnapshotStream_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                CloseSnapshotStream_Request_TypeSupportInterface () {};
                ~CloseSnapshotStream_Request_TypeSupportInterface () {};
            private:
                CloseSnapshotStream_Request_TypeSupportInterface (const CloseSnapshotStream_Request_TypeSupportInterface &);
                CloseSnapshotStream_Request_TypeSupportInterface & operator = (const CloseSnapshotStream_Request_TypeSupportInterface &);
            };

            class  CloseSnapshotStream_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef CloseSnapshotStream_Request_DataWriter_ptr _ptr_type;
                typedef CloseSnapshotStream_Request_DataWriter_var _var_type;

                static CloseSnapshotStream_Request_DataWriter_ptr _duplicate (CloseSnapshotStream_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CloseSnapshotStream_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static CloseSnapshotStream_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CloseSnapshotStream_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                CloseSnapshotStream_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const CloseSnapshotStream_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const CloseSnapshotStream_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const CloseSnapshotStream_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const CloseSnapshotStream_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const CloseSnapshotStream_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const CloseSnapshotStream_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const CloseSnapshotStream_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const CloseSnapshotStream_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const CloseSnapshotStream_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const CloseSnapshotStream_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (CloseSnapshotStream_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CloseSnapshotStream_Request_& instance_data) = 0;

            protected:
                CloseSnapshotStream_Request_DataWriter () {};
                ~CloseSnapshotStream_Request_DataWriter () {};
            private:
                CloseSnapshotStream_Request_DataWriter (const CloseSnapshotStream_Request_DataWriter &);
                CloseSnapshotStream_Request_DataWriter & operator = (const CloseSnapshotStream_Request_DataWriter &);
            };

            class  CloseSnapshotStream_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef CloseSnapshotStream_Request_DataReader_ptr _ptr_type;
                typedef CloseSnapshotStream_Request_DataReader_var _var_type;

                static CloseSnapshotStream_Request_DataReader_ptr _duplicate (CloseSnapshotStream_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CloseSnapshotStream_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static CloseSnapshotStream_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CloseSnapshotStream_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                CloseSnapshotStream_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (CloseSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (CloseSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (CloseSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (CloseSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (CloseSnapshotStream_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (CloseSnapshotStream_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (CloseSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (CloseSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (CloseSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (CloseSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (CloseSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (CloseSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (CloseSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (CloseSnapshotStream_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CloseSnapshotStream_Request_& instance) = 0;

            protected:
                CloseSnapshotStream_Request_DataReader () {};
                ~CloseSnapshotStream_Request_DataReader () {};
            private:
                CloseSnapshotStream_Request_DataReader (const CloseSnapshotStream_Request_DataReader &);
                CloseSnapshotStream_Request_DataReader & operator = (const CloseSnapshotStream_Request_DataReader &);
            };

            class  CloseSnapshotStream_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef CloseSnapshotStream_Request_DataReaderView_ptr _ptr_type;
                typedef CloseSnapshotStream_Request_DataReaderView_var _var_type;

                static CloseSnapshotStream_Request_DataReaderView_ptr _duplicate (CloseSnapshotStream_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CloseSnapshotStream_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static CloseSnapshotStream_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CloseSnapshotStream_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                CloseSnapshotStream_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (CloseSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (CloseSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (CloseSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (CloseSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (CloseSnapshotStream_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (CloseSnapshotStream_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (CloseSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (CloseSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (CloseSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (CloseSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (CloseSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (CloseSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (CloseSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (CloseSnapshotStream_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CloseSnapshotStream_Request_& instance) = 0;

            protected:
                CloseSnapshotStream_Request_DataReaderView () {};
                ~CloseSnapshotStream_Request_DataReaderView () {};
            private:
                CloseSnapshotStream_Request_DataReaderView (const CloseSnapshotStream_Request_DataReaderView &);
                CloseSnapshotStream_Request_DataReaderView & operator = (const CloseSnapshotStream_Request_DataReaderView &);
            };
            class CloseSnapshotStream_Response_TypeSupportInterface;

            typedef CloseSnapshotStream_Response_TypeSupportInterface * CloseSnapshotStream_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < CloseSnapshotStream_Response_TypeSupportInterface> CloseSnapshotStream_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < CloseSnapshotStream_Response_TypeSupportInterface> CloseSnapshotStream_Response_TypeSupportInterface_out;


            class CloseSnapshotStream_Response_DataWriter;

            typedef CloseSnapshotStream_Response_DataWriter * CloseSnapshotStream_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < CloseSnapshotStream_Response_DataWriter> CloseSnapshotStream_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < CloseSnapshotStream_Response_DataWriter> CloseSnapshotStream_Response_DataWriter_out;


            class CloseSnapshotStream_Response_DataReader;

            typedef CloseSnapshotStream_Response_DataReader * CloseSnapshotStream_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < CloseSnapshotStream_Response_DataReader> CloseSnapshotStream_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < CloseSnapshotStream_Response_DataReader> CloseSnapshotStream_Response_DataReader_out;


            class CloseSnapshotStream_Response_DataReaderView;

            typedef CloseSnapshotStream_Response_DataReaderView * CloseSnapshotStream_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < CloseSnapshotStream_Response_DataReaderView> CloseSnapshotStream_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < CloseSnapshotStream_Response_DataReaderView> CloseSnapshotStream_Response_DataReaderView_out;

            struct CloseSnapshotStream_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < CloseSnapshotStream_Response_, struct CloseSnapshotStream_Response_Seq_uniq_> CloseSnapshotStream_Response_Seq;
            typedef DDS_DCPSSequence_var < CloseSnapshotStream_Response_Seq> CloseSnapshotStream_Response_Seq_var;
            typedef DDS_DCPSSequence_out < CloseSnapshotStream_Response_Seq> CloseSnapshotStream_Response_Seq_out;

            class  CloseSnapshotStream_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef CloseSnapshotStream_Response_TypeSupportInterface_ptr _ptr_type;
                typedef CloseSnapshotStream_Response_TypeSupportInterface_var _var_type;

                static CloseSnapshotStream_Response_TypeSupportInterface_ptr _duplicate (CloseSnapshotStream_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CloseSnapshotStream_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static CloseSnapshotStream_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CloseSnapshotStream_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                CloseSnapshotStream_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                CloseSnapshotStream_Response_TypeSupportInterface () {};
                ~CloseSnapshotStream_Response_TypeSupportInterface () {};
            private:
                CloseSnapshotStream_Response_TypeSupportInterface (const CloseSnapshotStream_Response_TypeSupportInterface &);
                CloseSnapshotStream_Response_TypeSupportInterface & operator = (const CloseSnapshotStream_Response_TypeSupportInterface &);
            };

            class  CloseSnapshotStream_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef CloseSnapshotStream_Response_DataWriter_ptr _ptr_type;
                typedef CloseSnapshotStream_Response_DataWriter_var _var_type;

                static CloseSnapshotStream_Response_DataWriter_ptr _duplicate (CloseSnapshotStream_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CloseSnapshotStream_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static CloseSnapshotStream_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CloseSnapshotStream_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                CloseSnapshotStream_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const CloseSnapshotStream_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const CloseSnapshotStream_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const CloseSnapshotStream_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const CloseSnapshotStream_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const CloseSnapshotStream_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const CloseSnapshotStream_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const CloseSnapshotStream_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const CloseSnapshotStream_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const CloseSnapshotStream_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const CloseSnapshotStream_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (CloseSnapshotStream_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CloseSnapshotStream_Response_& instance_data) = 0;

            protected:
                CloseSnapshotStream_Response_DataWriter () {};
                ~CloseSnapshotStream_Response_DataWriter () {};
            private:
                CloseSnapshotStream_Response_DataWriter (const CloseSnapshotStream_Response_DataWriter &);
                CloseSnapshotStream_Response_DataWriter & operator = (const CloseSnapshotStream_Response_DataWriter &);
            };

            class  CloseSnapshotStream_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef CloseSnapshotStream_Response_DataReader_ptr _ptr_type;
                typedef CloseSnapshotStream_Response_DataReader_var _var_type;

                static CloseSnapshotStream_Response_DataReader_ptr _duplicate (CloseSnapshotStream_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CloseSnapshotStream_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static CloseSnapshotStream_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CloseSnapshotStream_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                CloseSnapshotStream_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (CloseSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (CloseSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (CloseSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (CloseSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (CloseSnapshotStream_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (CloseSnapshotStream_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (CloseSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (CloseSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (CloseSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (CloseSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (CloseSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (CloseSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (CloseSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (CloseSnapshotStream_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CloseSnapshotStream_Response_& instance) = 0;

            protected:
                CloseSnapshotStream_Response_DataReader () {};
                ~CloseSnapshotStream_Response_DataReader () {};
            private:
                CloseSnapshotStream_Response_DataReader (const CloseSnapshotStream_Response_DataReader &);
                CloseSnapshotStream_Response_DataReader & operator = (const CloseSnapshotStream_Response_DataReader &);
            };

            class  CloseSnapshotStream_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef CloseSnapshotStream_Response_DataReaderView_ptr _ptr_type;
                typedef CloseSnapshotStream_Response_DataReaderView_var _var_type;

                static CloseSnapshotStream_Response_DataReaderView_ptr _duplicate (CloseSnapshotStream_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CloseSnapshotStream_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static CloseSnapshotStream_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CloseSnapshotStream_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                CloseSnapshotStream_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (CloseSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (CloseSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (CloseSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (CloseSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (CloseSnapshotStream_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (CloseSnapshotStream_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (CloseSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (CloseSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (CloseSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (CloseSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (CloseSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (CloseSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (CloseSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (CloseSnapshotStream_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CloseSnapshotStream_Response_& instance) = 0;

            protected:
                CloseSnapshotStream_Response_DataReaderView () {};
                ~CloseSnapshotStream_Response_DataReaderView () {};
            private:
                CloseSnapshotStream_Response_DataReaderView (const CloseSnapshotStream_Response_DataReaderView &);
                CloseSnapshotStream_Response_DataReaderView & operator = (const CloseSnapshotStream_Response_DataReaderView &);
            };
            class Sample_CloseSnapshotStream_Request_TypeSupportInterface;

            typedef Sample_CloseSnapshotStream_Request_TypeSupportInterface * Sample_CloseSnapshotStream_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_CloseSnapshotStream_Request_TypeSupportInterface> Sample_CloseSnapshotStream_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_CloseSnapshotStream_Request_TypeSupportInterface> Sample_CloseSnapshotStream_Request_TypeSupportInterface_out;


            class Sample_CloseSnapshotStream_Request_DataWriter;

            typedef Sample_CloseSnapshotStream_Request_DataWriter * Sample_CloseSnapshotStream_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_CloseSnapshotStream_Request_DataWriter> Sample_CloseSnapshotStream_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_CloseSnapshotStream_Request_DataWriter> Sample_CloseSnapshotStream_Request_DataWriter_out;


            class Sample_CloseSnapshotStream_Request_DataReader;

            typedef Sample_CloseSnapshotStream_Request_DataReader * Sample_CloseSnapshotStream_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_CloseSnapshotStream_Request_DataReader> Sample_CloseSnapshotStream_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_CloseSnapshotStream_Request_DataReader> Sample_CloseSnapshotStream_Request_DataReader_out;


            class Sample_CloseSnapshotStream_Request_DataReaderView;

            typedef Sample_CloseSnapshotStream_Request_DataReaderView * Sample_CloseSnapshotStream_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_CloseSnapshotStream_Request_DataReaderView> Sample_CloseSnapshotStream_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_CloseSnapshotStream_Request_DataReaderView> Sample_CloseSnapshotStream_Request_DataReaderView_out;

            struct Sample_CloseSnapshotStream_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_CloseSnapshotStream_Request_, struct Sample_CloseSnapshotStream_Request_Seq_uniq_> Sample_CloseSnapshotStream_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_CloseSnapshotStream_Request_Seq> Sample_CloseSnapshotStream_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_CloseSnapshotStream_Request_Seq> Sample_CloseSnapshotStream_Request_Seq_out;

            class  Sample_CloseSnapshotStream_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_CloseSnapshotStream_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_CloseSnapshotStream_Request_TypeSupportInterface_var _var_type;

                static Sample_CloseSnapshotStream_Request_TypeSupportInterface_ptr _duplicate (Sample_CloseSnapshotStream_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_CloseSnapshotStream_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_CloseSnapshotStream_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_CloseSnapshotStream_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_CloseSnapshotStream_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_CloseSnapshotStream_Request_TypeSupportInterface () {};
                ~Sample_CloseSnapshotStream_Request_TypeSupportInterface () {};
            private:
                Sample_CloseSnapshotStream_Request_TypeSupportInterface (const Sample_CloseSnapshotStream_Request_TypeSupportInterface &);
                Sample_CloseSnapshotStream_Request_TypeSupportInterface & operator = (const Sample_CloseSnapshotStream_Request_TypeSupportInterface &);
            };

            class  Sample_CloseSnapshotStream_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_CloseSnapshotStream_Request_DataWriter_ptr _ptr_type;
                typedef Sample_CloseSnapshotStream_Request_DataWriter_var _var_type;

                static Sample_CloseSnapshotStream_Request_DataWriter_ptr _duplicate (Sample_CloseSnapshotStream_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_CloseSnapshotStream_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_CloseSnapshotStream_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_CloseSnapshotStream_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_CloseSnapshotStream_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_CloseSnapshotStream_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_CloseSnapshotStream_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_CloseSnapshotStream_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_CloseSnapshotStream_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_CloseSnapshotStream_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_CloseSnapshotStream_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_CloseSnapshotStream_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_CloseSnapshotStream_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_CloseSnapshotStream_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_CloseSnapshotStream_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_CloseSnapshotStream_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_CloseSnapshotStream_Request_& instance_data) = 0;

            protected:
                Sample_CloseSnapshotStream_Request_DataWriter () {};
                ~Sample_CloseSnapshotStream_Request_DataWriter () {};
            private:
                Sample_CloseSnapshotStream_Request_DataWriter (const Sample_CloseSnapshotStream_Request_DataWriter &);
                Sample_CloseSnapshotStream_Request_DataWriter & operator = (const Sample_CloseSnapshotStream_Request_DataWriter &);
            };

            class  Sample_CloseSnapshotStream_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_CloseSnapshotStream_Request_DataReader_ptr _ptr_type;
                typedef Sample_CloseSnapshotStream_Request_DataReader_var _var_type;

                static Sample_CloseSnapshotStream_Request_DataReader_ptr _duplicate (Sample_CloseSnapshotStream_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_CloseSnapshotStream_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_CloseSnapshotStream_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_CloseSnapshotStream_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_CloseSnapshotStream_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_CloseSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_CloseSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_CloseSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_CloseSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_CloseSnapshotStream_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_CloseSnapshotStream_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_CloseSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_CloseSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_CloseSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_CloseSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_CloseSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_CloseSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_CloseSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_CloseSnapshotStream_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_CloseSnapshotStream_Request_& instance) = 0;

            protected:
                Sample_CloseSnapshotStream_Request_DataReader () {};
                ~Sample_CloseSnapshotStream_Request_DataReader () {};
            private:
                Sample_CloseSnapshotStream_Request_DataReader (const Sample_CloseSnapshotStream_Request_DataReader &);
                Sample_CloseSnapshotStream_Request_DataReader & operator = (const Sample_CloseSnapshotStream_Request_DataReader &);
            };

            class  Sample_CloseSnapshotStream_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_CloseSnapshotStream_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_CloseSnapshotStream_Request_DataReaderView_var _var_type;

                static Sample_CloseSnapshotStream_Request_DataReaderView_ptr _duplicate (Sample_CloseSnapshotStream_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_CloseSnapshotStream_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_CloseSnapshotStream_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_CloseSnapshotStream_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_CloseSnapshotStream_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_CloseSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_CloseSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_CloseSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_CloseSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_CloseSnapshotStream_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_CloseSnapshotStream_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_CloseSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_CloseSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_CloseSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_CloseSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_CloseSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_CloseSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_CloseSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_CloseSnapshotStream_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_CloseSnapshotStream_Request_& instance) = 0;

            protected:
                Sample_CloseSnapshotStream_Request_DataReaderView () {};
                ~Sample_CloseSnapshotStream_Request_DataReaderView () {};
            private:
                Sample_CloseSnapshotStream_Request_DataReaderView (const Sample_CloseSnapshotStream_Request_DataReaderView &);
                Sample_CloseSnapshotStream_Request_DataReaderView & operator = (const Sample_CloseSnapshotStream_Request_DataReaderView &);
            };
            class Sample_CloseSnapshotStream_Response_TypeSupportInterface;

            typedef Sample_CloseSnapshotStream_Response_TypeSupportInterface * Sample_CloseSnapshotStream_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_CloseSnapshotStream_Response_TypeSupportInterface> Sample_CloseSnapshotStream_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_CloseSnapshotStream_Response_TypeSupportInterface> Sample_CloseSnapshotStream_Response_TypeSupportInterface_out;


            class Sample_CloseSnapshotStream_Response_DataWriter;

            typedef Sample_CloseSnapshotStream_Response_DataWriter * Sample_CloseSnapshotStream_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_CloseSnapshotStream_Response_DataWriter> Sample_CloseSnapshotStream_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_CloseSnapshotStream_Response_DataWriter> Sample_CloseSnapshotStream_Response_DataWriter_out;


            class Sample_CloseSnapshotStream_Response_DataReader;

            typedef Sample_CloseSnapshotStream_Response_DataReader * Sample_CloseSnapshotStream_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_CloseSnapshotStream_Response_DataReader> Sample_CloseSnapshotStream_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_CloseSnapshotStream_Response_DataReader> Sample_CloseSnapshotStream_Response_DataReader_out;


            class Sample_CloseSnapshotStream_Response_DataReaderView;

            typedef Sample_CloseSnapshotStream_Response_DataReaderView * Sample_CloseSnapshotStream_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_CloseSnapshotStream_Response_DataReaderView> Sample_CloseSnapshotStream_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_CloseSnapshotStream_Response_DataReaderView> Sample_CloseSnapshotStream_Response_DataReaderView_out;

            struct Sample_CloseSnapshotStream_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_CloseSnapshotStream_Response_, struct Sample_CloseSnapshotStream_Response_Seq_uniq_> Sample_CloseSnapshotStream_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_CloseSnapshotStream_Response_Seq> Sample_CloseSnapshotStream_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_CloseSnapshotStream_Response_Seq> Sample_CloseSnapshotStream_Response_Seq_out;

            class  Sample_CloseSnapshotStream_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_CloseSnapshotStream_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_CloseSnapshotStream_Response_TypeSupportInterface_var _var_type;

                static Sample_CloseSnapshotStream_Response_TypeSupportInterface_ptr _duplicate (Sample_CloseSnapshotStream_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_CloseSnapshotStream_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_CloseSnapshotStream_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_CloseSnapshotStream_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_CloseSnapshotStream_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_CloseSnapshotStream_Response_TypeSupportInterface () {};
                ~Sample_CloseSnapshotStream_Response_TypeSupportInterface () {};
            private:
                Sample_CloseSnapshotStream_Response_TypeSupportInterface (const Sample_CloseSnapshotStream_Response_TypeSupportInterface &);
                Sample_CloseSnapshotStream_Response_TypeSupportInterface & operator = (const Sample_CloseSnapshotStream_Response_TypeSupportInterface &);
            };

            class  Sample_CloseSnapshotStream_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_CloseSnapshotStream_Response_DataWriter_ptr _ptr_type;
                typedef Sample_CloseSnapshotStream_Response_DataWriter_var _var_type;

                static Sample_CloseSnapshotStream_Response_DataWriter_ptr _duplicate (Sample_CloseSnapshotStream_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_CloseSnapshotStream_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_CloseSnapshotStream_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_CloseSnapshotStream_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_CloseSnapshotStream_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_CloseSnapshotStream_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_CloseSnapshotStream_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_CloseSnapshotStream_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_CloseSnapshotStream_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_CloseSnapshotStream_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_CloseSnapshotStream_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_CloseSnapshotStream_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_CloseSnapshotStream_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_CloseSnapshotStream_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_CloseSnapshotStream_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_CloseSnapshotStream_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_CloseSnapshotStream_Response_& instance_data) = 0;

            protected:
                Sample_CloseSnapshotStream_Response_DataWriter () {};
                ~Sample_CloseSnapshotStream_Response_DataWriter () {};
            private:
                Sample_CloseSnapshotStream_Response_DataWriter (const Sample_CloseSnapshotStream_Response_DataWriter &);
                Sample_CloseSnapshotStream_Response_DataWriter & operator = (const Sample_CloseSnapshotStream_Response_DataWriter &);
            };

            class  Sample_CloseSnapshotStream_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_CloseSnapshotStream_Response_DataReader_ptr _ptr_type;
                typedef Sample_CloseSnapshotStream_Response_DataReader_var _var_type;

                static Sample_CloseSnapshotStream_Response_DataReader_ptr _duplicate (Sample_CloseSnapshotStream_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_CloseSnapshotStream_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_CloseSnapshotStream_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_CloseSnapshotStream_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_CloseSnapshotStream_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_CloseSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_CloseSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_CloseSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_CloseSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_CloseSnapshotStream_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_CloseSnapshotStream_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_CloseSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_CloseSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_CloseSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_CloseSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_CloseSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_CloseSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_CloseSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_CloseSnapshotStream_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_CloseSnapshotStream_Response_& instance) = 0;

            protected:
                Sample_CloseSnapshotStream_Response_DataReader () {};
                ~Sample_CloseSnapshotStream_Response_DataReader () {};
            private:
                Sample_CloseSnapshotStream_Response_DataReader (const Sample_CloseSnapshotStream_Response_DataReader &);
                Sample_CloseSnapshotStream_Response_DataReader & operator = (const Sample_CloseSnapshotStream_Response_DataReader &);
            };

            class  Sample_CloseSnapshotStream_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_CloseSnapshotStream_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_CloseSnapshotStream_Response_DataReaderView_var _var_type;

                static Sample_CloseSnapshotStream_Response_DataReaderView_ptr _duplicate (Sample_CloseSnapshotStream_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_CloseSnapshotStream_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_CloseSnapshotStream_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_CloseSnapshotStream_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_CloseSnapshotStream_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_CloseSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_CloseSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_CloseSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_CloseSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_CloseSnapshotStream_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_CloseSnapshotStream_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_CloseSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_CloseSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_CloseSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_CloseSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_CloseSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_CloseSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_CloseSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_CloseSnapshotStream_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_CloseSnapshotStream_Response_& instance) = 0;

            protected:
                Sample_CloseSnapshotStream_Response_DataReaderView () {};
                ~Sample_CloseSnapshotStream_Response_DataReaderView () {};
            private:
                Sample_CloseSnapshotStream_Response_DataReaderView (const Sample_CloseSnapshotStream_Response_DataReaderView &);
                Sample_CloseSnapshotStream_Response_DataReaderView & operator = (const Sample_CloseSnapshotStream_Response_DataReaderView &);
            };
        }

    }

}

#endif
