#ifndef _H_F272478E5A43B505E78ED1048E24EC7F_IntrospectServices__H_
#define _H_F272478E5A43B505E78ED1048E24EC7F_IntrospectServices__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "py_trees_ros_interfaces/msg/dds_opensplice/ServiceDetails_.h"


namespace py_trees_ros_interfaces
{
    namespace srv
    {
        namespace dds_
        {
            struct  IntrospectServices_Request_
            {
                ::DDS::Octet structure_needs_at_least_one_member_;
            };

            typedef DDS_DCPSStruct_var<IntrospectServices_Request_> IntrospectServices_Request__var;
            typedef IntrospectServices_Request_& IntrospectServices_Request__out;

            struct  IntrospectServices_Response_
            {
                struct _service_details__seq_uniq_{};
                typedef DDS_DCPSUVLSeq< ::py_trees_ros_interfaces::msg::dds_::ServiceDetails_, struct _service_details__seq_uniq_ > _service_details__seq;
                typedef DDS_DCPSSequence_var< _service_details__seq > _service_details__seq_var;
                typedef DDS_DCPSSequence_out< _service_details__seq > _service_details__seq_out;
                _service_details__seq service_details_;
            };

            typedef DDS_DCPSStruct_var<IntrospectServices_Response_> IntrospectServices_Response__var;
            typedef DDS_DCPSStruct_out < IntrospectServices_Response_> IntrospectServices_Response__out;

            struct  Sample_IntrospectServices_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::py_trees_ros_interfaces::srv::dds_::IntrospectServices_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_IntrospectServices_Request_> Sample_IntrospectServices_Request__var;
            typedef Sample_IntrospectServices_Request_& Sample_IntrospectServices_Request__out;

            struct  Sample_IntrospectServices_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::py_trees_ros_interfaces::srv::dds_::IntrospectServices_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_IntrospectServices_Response_> Sample_IntrospectServices_Response__var;
            typedef DDS_DCPSStruct_out < Sample_IntrospectServices_Response_> Sample_IntrospectServices_Response__out;

        }

    }

}

#endif /* _H_F272478E5A43B505E78ED1048E24EC7F_IntrospectServices__H_ */
