#ifndef _H_F272478E5A43B505E78ED1048E24EC7F_IntrospectServices_DCPS_H_
#define _H_F272478E5A43B505E78ED1048E24EC7F_IntrospectServices_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "IntrospectServices_.h"


namespace py_trees_ros_interfaces
{
    namespace srv
    {
        namespace dds_
        {
            class IntrospectServices_Request_TypeSupportInterface;

            typedef IntrospectServices_Request_TypeSupportInterface * IntrospectServices_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < IntrospectServices_Request_TypeSupportInterface> IntrospectServices_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < IntrospectServices_Request_TypeSupportInterface> IntrospectServices_Request_TypeSupportInterface_out;


            class IntrospectServices_Request_DataWriter;

            typedef IntrospectServices_Request_DataWriter * IntrospectServices_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < IntrospectServices_Request_DataWriter> IntrospectServices_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < IntrospectServices_Request_DataWriter> IntrospectServices_Request_DataWriter_out;


            class IntrospectServices_Request_DataReader;

            typedef IntrospectServices_Request_DataReader * IntrospectServices_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < IntrospectServices_Request_DataReader> IntrospectServices_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < IntrospectServices_Request_DataReader> IntrospectServices_Request_DataReader_out;


            class IntrospectServices_Request_DataReaderView;

            typedef IntrospectServices_Request_DataReaderView * IntrospectServices_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < IntrospectServices_Request_DataReaderView> IntrospectServices_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < IntrospectServices_Request_DataReaderView> IntrospectServices_Request_DataReaderView_out;

            struct IntrospectServices_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < IntrospectServices_Request_, struct IntrospectServices_Request_Seq_uniq_> IntrospectServices_Request_Seq;
            typedef DDS_DCPSSequence_var < IntrospectServices_Request_Seq> IntrospectServices_Request_Seq_var;
            typedef DDS_DCPSSequence_out < IntrospectServices_Request_Seq> IntrospectServices_Request_Seq_out;

            class  IntrospectServices_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef IntrospectServices_Request_TypeSupportInterface_ptr _ptr_type;
                typedef IntrospectServices_Request_TypeSupportInterface_var _var_type;

                static IntrospectServices_Request_TypeSupportInterface_ptr _duplicate (IntrospectServices_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IntrospectServices_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static IntrospectServices_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IntrospectServices_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                IntrospectServices_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                IntrospectServices_Request_TypeSupportInterface () {};
                ~IntrospectServices_Request_TypeSupportInterface () {};
            private:
                IntrospectServices_Request_TypeSupportInterface (const IntrospectServices_Request_TypeSupportInterface &);
                IntrospectServices_Request_TypeSupportInterface & operator = (const IntrospectServices_Request_TypeSupportInterface &);
            };

            class  IntrospectServices_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef IntrospectServices_Request_DataWriter_ptr _ptr_type;
                typedef IntrospectServices_Request_DataWriter_var _var_type;

                static IntrospectServices_Request_DataWriter_ptr _duplicate (IntrospectServices_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IntrospectServices_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static IntrospectServices_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IntrospectServices_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                IntrospectServices_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const IntrospectServices_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const IntrospectServices_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const IntrospectServices_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const IntrospectServices_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const IntrospectServices_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const IntrospectServices_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const IntrospectServices_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const IntrospectServices_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const IntrospectServices_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const IntrospectServices_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (IntrospectServices_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const IntrospectServices_Request_& instance_data) = 0;

            protected:
                IntrospectServices_Request_DataWriter () {};
                ~IntrospectServices_Request_DataWriter () {};
            private:
                IntrospectServices_Request_DataWriter (const IntrospectServices_Request_DataWriter &);
                IntrospectServices_Request_DataWriter & operator = (const IntrospectServices_Request_DataWriter &);
            };

            class  IntrospectServices_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef IntrospectServices_Request_DataReader_ptr _ptr_type;
                typedef IntrospectServices_Request_DataReader_var _var_type;

                static IntrospectServices_Request_DataReader_ptr _duplicate (IntrospectServices_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IntrospectServices_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static IntrospectServices_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IntrospectServices_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                IntrospectServices_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (IntrospectServices_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (IntrospectServices_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (IntrospectServices_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (IntrospectServices_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (IntrospectServices_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (IntrospectServices_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (IntrospectServices_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (IntrospectServices_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (IntrospectServices_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (IntrospectServices_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (IntrospectServices_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (IntrospectServices_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (IntrospectServices_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (IntrospectServices_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const IntrospectServices_Request_& instance) = 0;

            protected:
                IntrospectServices_Request_DataReader () {};
                ~IntrospectServices_Request_DataReader () {};
            private:
                IntrospectServices_Request_DataReader (const IntrospectServices_Request_DataReader &);
                IntrospectServices_Request_DataReader & operator = (const IntrospectServices_Request_DataReader &);
            };

            class  IntrospectServices_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef IntrospectServices_Request_DataReaderView_ptr _ptr_type;
                typedef IntrospectServices_Request_DataReaderView_var _var_type;

                static IntrospectServices_Request_DataReaderView_ptr _duplicate (IntrospectServices_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IntrospectServices_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static IntrospectServices_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IntrospectServices_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                IntrospectServices_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (IntrospectServices_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (IntrospectServices_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (IntrospectServices_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (IntrospectServices_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (IntrospectServices_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (IntrospectServices_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (IntrospectServices_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (IntrospectServices_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (IntrospectServices_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (IntrospectServices_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (IntrospectServices_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (IntrospectServices_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (IntrospectServices_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (IntrospectServices_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const IntrospectServices_Request_& instance) = 0;

            protected:
                IntrospectServices_Request_DataReaderView () {};
                ~IntrospectServices_Request_DataReaderView () {};
            private:
                IntrospectServices_Request_DataReaderView (const IntrospectServices_Request_DataReaderView &);
                IntrospectServices_Request_DataReaderView & operator = (const IntrospectServices_Request_DataReaderView &);
            };
            class IntrospectServices_Response_TypeSupportInterface;

            typedef IntrospectServices_Response_TypeSupportInterface * IntrospectServices_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < IntrospectServices_Response_TypeSupportInterface> IntrospectServices_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < IntrospectServices_Response_TypeSupportInterface> IntrospectServices_Response_TypeSupportInterface_out;


            class IntrospectServices_Response_DataWriter;

            typedef IntrospectServices_Response_DataWriter * IntrospectServices_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < IntrospectServices_Response_DataWriter> IntrospectServices_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < IntrospectServices_Response_DataWriter> IntrospectServices_Response_DataWriter_out;


            class IntrospectServices_Response_DataReader;

            typedef IntrospectServices_Response_DataReader * IntrospectServices_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < IntrospectServices_Response_DataReader> IntrospectServices_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < IntrospectServices_Response_DataReader> IntrospectServices_Response_DataReader_out;


            class IntrospectServices_Response_DataReaderView;

            typedef IntrospectServices_Response_DataReaderView * IntrospectServices_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < IntrospectServices_Response_DataReaderView> IntrospectServices_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < IntrospectServices_Response_DataReaderView> IntrospectServices_Response_DataReaderView_out;

            struct IntrospectServices_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < IntrospectServices_Response_, struct IntrospectServices_Response_Seq_uniq_> IntrospectServices_Response_Seq;
            typedef DDS_DCPSSequence_var < IntrospectServices_Response_Seq> IntrospectServices_Response_Seq_var;
            typedef DDS_DCPSSequence_out < IntrospectServices_Response_Seq> IntrospectServices_Response_Seq_out;

            class  IntrospectServices_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef IntrospectServices_Response_TypeSupportInterface_ptr _ptr_type;
                typedef IntrospectServices_Response_TypeSupportInterface_var _var_type;

                static IntrospectServices_Response_TypeSupportInterface_ptr _duplicate (IntrospectServices_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IntrospectServices_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static IntrospectServices_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IntrospectServices_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                IntrospectServices_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                IntrospectServices_Response_TypeSupportInterface () {};
                ~IntrospectServices_Response_TypeSupportInterface () {};
            private:
                IntrospectServices_Response_TypeSupportInterface (const IntrospectServices_Response_TypeSupportInterface &);
                IntrospectServices_Response_TypeSupportInterface & operator = (const IntrospectServices_Response_TypeSupportInterface &);
            };

            class  IntrospectServices_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef IntrospectServices_Response_DataWriter_ptr _ptr_type;
                typedef IntrospectServices_Response_DataWriter_var _var_type;

                static IntrospectServices_Response_DataWriter_ptr _duplicate (IntrospectServices_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IntrospectServices_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static IntrospectServices_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IntrospectServices_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                IntrospectServices_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const IntrospectServices_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const IntrospectServices_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const IntrospectServices_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const IntrospectServices_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const IntrospectServices_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const IntrospectServices_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const IntrospectServices_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const IntrospectServices_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const IntrospectServices_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const IntrospectServices_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (IntrospectServices_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const IntrospectServices_Response_& instance_data) = 0;

            protected:
                IntrospectServices_Response_DataWriter () {};
                ~IntrospectServices_Response_DataWriter () {};
            private:
                IntrospectServices_Response_DataWriter (const IntrospectServices_Response_DataWriter &);
                IntrospectServices_Response_DataWriter & operator = (const IntrospectServices_Response_DataWriter &);
            };

            class  IntrospectServices_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef IntrospectServices_Response_DataReader_ptr _ptr_type;
                typedef IntrospectServices_Response_DataReader_var _var_type;

                static IntrospectServices_Response_DataReader_ptr _duplicate (IntrospectServices_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IntrospectServices_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static IntrospectServices_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IntrospectServices_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                IntrospectServices_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (IntrospectServices_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (IntrospectServices_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (IntrospectServices_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (IntrospectServices_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (IntrospectServices_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (IntrospectServices_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (IntrospectServices_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (IntrospectServices_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (IntrospectServices_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (IntrospectServices_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (IntrospectServices_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (IntrospectServices_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (IntrospectServices_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (IntrospectServices_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const IntrospectServices_Response_& instance) = 0;

            protected:
                IntrospectServices_Response_DataReader () {};
                ~IntrospectServices_Response_DataReader () {};
            private:
                IntrospectServices_Response_DataReader (const IntrospectServices_Response_DataReader &);
                IntrospectServices_Response_DataReader & operator = (const IntrospectServices_Response_DataReader &);
            };

            class  IntrospectServices_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef IntrospectServices_Response_DataReaderView_ptr _ptr_type;
                typedef IntrospectServices_Response_DataReaderView_var _var_type;

                static IntrospectServices_Response_DataReaderView_ptr _duplicate (IntrospectServices_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IntrospectServices_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static IntrospectServices_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IntrospectServices_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                IntrospectServices_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (IntrospectServices_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (IntrospectServices_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (IntrospectServices_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (IntrospectServices_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (IntrospectServices_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (IntrospectServices_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (IntrospectServices_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (IntrospectServices_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (IntrospectServices_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (IntrospectServices_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (IntrospectServices_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (IntrospectServices_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (IntrospectServices_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (IntrospectServices_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const IntrospectServices_Response_& instance) = 0;

            protected:
                IntrospectServices_Response_DataReaderView () {};
                ~IntrospectServices_Response_DataReaderView () {};
            private:
                IntrospectServices_Response_DataReaderView (const IntrospectServices_Response_DataReaderView &);
                IntrospectServices_Response_DataReaderView & operator = (const IntrospectServices_Response_DataReaderView &);
            };
            class Sample_IntrospectServices_Request_TypeSupportInterface;

            typedef Sample_IntrospectServices_Request_TypeSupportInterface * Sample_IntrospectServices_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_IntrospectServices_Request_TypeSupportInterface> Sample_IntrospectServices_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_IntrospectServices_Request_TypeSupportInterface> Sample_IntrospectServices_Request_TypeSupportInterface_out;


            class Sample_IntrospectServices_Request_DataWriter;

            typedef Sample_IntrospectServices_Request_DataWriter * Sample_IntrospectServices_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_IntrospectServices_Request_DataWriter> Sample_IntrospectServices_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_IntrospectServices_Request_DataWriter> Sample_IntrospectServices_Request_DataWriter_out;


            class Sample_IntrospectServices_Request_DataReader;

            typedef Sample_IntrospectServices_Request_DataReader * Sample_IntrospectServices_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_IntrospectServices_Request_DataReader> Sample_IntrospectServices_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_IntrospectServices_Request_DataReader> Sample_IntrospectServices_Request_DataReader_out;


            class Sample_IntrospectServices_Request_DataReaderView;

            typedef Sample_IntrospectServices_Request_DataReaderView * Sample_IntrospectServices_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_IntrospectServices_Request_DataReaderView> Sample_IntrospectServices_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_IntrospectServices_Request_DataReaderView> Sample_IntrospectServices_Request_DataReaderView_out;

            struct Sample_IntrospectServices_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_IntrospectServices_Request_, struct Sample_IntrospectServices_Request_Seq_uniq_> Sample_IntrospectServices_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_IntrospectServices_Request_Seq> Sample_IntrospectServices_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_IntrospectServices_Request_Seq> Sample_IntrospectServices_Request_Seq_out;

            class  Sample_IntrospectServices_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_IntrospectServices_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_IntrospectServices_Request_TypeSupportInterface_var _var_type;

                static Sample_IntrospectServices_Request_TypeSupportInterface_ptr _duplicate (Sample_IntrospectServices_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_IntrospectServices_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_IntrospectServices_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_IntrospectServices_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_IntrospectServices_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_IntrospectServices_Request_TypeSupportInterface () {};
                ~Sample_IntrospectServices_Request_TypeSupportInterface () {};
            private:
                Sample_IntrospectServices_Request_TypeSupportInterface (const Sample_IntrospectServices_Request_TypeSupportInterface &);
                Sample_IntrospectServices_Request_TypeSupportInterface & operator = (const Sample_IntrospectServices_Request_TypeSupportInterface &);
            };

            class  Sample_IntrospectServices_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_IntrospectServices_Request_DataWriter_ptr _ptr_type;
                typedef Sample_IntrospectServices_Request_DataWriter_var _var_type;

                static Sample_IntrospectServices_Request_DataWriter_ptr _duplicate (Sample_IntrospectServices_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_IntrospectServices_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_IntrospectServices_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_IntrospectServices_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_IntrospectServices_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_IntrospectServices_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_IntrospectServices_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_IntrospectServices_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_IntrospectServices_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_IntrospectServices_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_IntrospectServices_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_IntrospectServices_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_IntrospectServices_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_IntrospectServices_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_IntrospectServices_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_IntrospectServices_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_IntrospectServices_Request_& instance_data) = 0;

            protected:
                Sample_IntrospectServices_Request_DataWriter () {};
                ~Sample_IntrospectServices_Request_DataWriter () {};
            private:
                Sample_IntrospectServices_Request_DataWriter (const Sample_IntrospectServices_Request_DataWriter &);
                Sample_IntrospectServices_Request_DataWriter & operator = (const Sample_IntrospectServices_Request_DataWriter &);
            };

            class  Sample_IntrospectServices_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_IntrospectServices_Request_DataReader_ptr _ptr_type;
                typedef Sample_IntrospectServices_Request_DataReader_var _var_type;

                static Sample_IntrospectServices_Request_DataReader_ptr _duplicate (Sample_IntrospectServices_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_IntrospectServices_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_IntrospectServices_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_IntrospectServices_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_IntrospectServices_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_IntrospectServices_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_IntrospectServices_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_IntrospectServices_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_IntrospectServices_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_IntrospectServices_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_IntrospectServices_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_IntrospectServices_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_IntrospectServices_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_IntrospectServices_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_IntrospectServices_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_IntrospectServices_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_IntrospectServices_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_IntrospectServices_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_IntrospectServices_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_IntrospectServices_Request_& instance) = 0;

            protected:
                Sample_IntrospectServices_Request_DataReader () {};
                ~Sample_IntrospectServices_Request_DataReader () {};
            private:
                Sample_IntrospectServices_Request_DataReader (const Sample_IntrospectServices_Request_DataReader &);
                Sample_IntrospectServices_Request_DataReader & operator = (const Sample_IntrospectServices_Request_DataReader &);
            };

            class  Sample_IntrospectServices_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_IntrospectServices_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_IntrospectServices_Request_DataReaderView_var _var_type;

                static Sample_IntrospectServices_Request_DataReaderView_ptr _duplicate (Sample_IntrospectServices_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_IntrospectServices_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_IntrospectServices_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_IntrospectServices_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_IntrospectServices_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_IntrospectServices_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_IntrospectServices_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_IntrospectServices_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_IntrospectServices_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_IntrospectServices_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_IntrospectServices_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_IntrospectServices_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_IntrospectServices_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_IntrospectServices_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_IntrospectServices_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_IntrospectServices_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_IntrospectServices_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_IntrospectServices_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_IntrospectServices_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_IntrospectServices_Request_& instance) = 0;

            protected:
                Sample_IntrospectServices_Request_DataReaderView () {};
                ~Sample_IntrospectServices_Request_DataReaderView () {};
            private:
                Sample_IntrospectServices_Request_DataReaderView (const Sample_IntrospectServices_Request_DataReaderView &);
                Sample_IntrospectServices_Request_DataReaderView & operator = (const Sample_IntrospectServices_Request_DataReaderView &);
            };
            class Sample_IntrospectServices_Response_TypeSupportInterface;

            typedef Sample_IntrospectServices_Response_TypeSupportInterface * Sample_IntrospectServices_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_IntrospectServices_Response_TypeSupportInterface> Sample_IntrospectServices_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_IntrospectServices_Response_TypeSupportInterface> Sample_IntrospectServices_Response_TypeSupportInterface_out;


            class Sample_IntrospectServices_Response_DataWriter;

            typedef Sample_IntrospectServices_Response_DataWriter * Sample_IntrospectServices_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_IntrospectServices_Response_DataWriter> Sample_IntrospectServices_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_IntrospectServices_Response_DataWriter> Sample_IntrospectServices_Response_DataWriter_out;


            class Sample_IntrospectServices_Response_DataReader;

            typedef Sample_IntrospectServices_Response_DataReader * Sample_IntrospectServices_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_IntrospectServices_Response_DataReader> Sample_IntrospectServices_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_IntrospectServices_Response_DataReader> Sample_IntrospectServices_Response_DataReader_out;


            class Sample_IntrospectServices_Response_DataReaderView;

            typedef Sample_IntrospectServices_Response_DataReaderView * Sample_IntrospectServices_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_IntrospectServices_Response_DataReaderView> Sample_IntrospectServices_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_IntrospectServices_Response_DataReaderView> Sample_IntrospectServices_Response_DataReaderView_out;

            struct Sample_IntrospectServices_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_IntrospectServices_Response_, struct Sample_IntrospectServices_Response_Seq_uniq_> Sample_IntrospectServices_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_IntrospectServices_Response_Seq> Sample_IntrospectServices_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_IntrospectServices_Response_Seq> Sample_IntrospectServices_Response_Seq_out;

            class  Sample_IntrospectServices_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_IntrospectServices_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_IntrospectServices_Response_TypeSupportInterface_var _var_type;

                static Sample_IntrospectServices_Response_TypeSupportInterface_ptr _duplicate (Sample_IntrospectServices_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_IntrospectServices_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_IntrospectServices_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_IntrospectServices_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_IntrospectServices_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_IntrospectServices_Response_TypeSupportInterface () {};
                ~Sample_IntrospectServices_Response_TypeSupportInterface () {};
            private:
                Sample_IntrospectServices_Response_TypeSupportInterface (const Sample_IntrospectServices_Response_TypeSupportInterface &);
                Sample_IntrospectServices_Response_TypeSupportInterface & operator = (const Sample_IntrospectServices_Response_TypeSupportInterface &);
            };

            class  Sample_IntrospectServices_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_IntrospectServices_Response_DataWriter_ptr _ptr_type;
                typedef Sample_IntrospectServices_Response_DataWriter_var _var_type;

                static Sample_IntrospectServices_Response_DataWriter_ptr _duplicate (Sample_IntrospectServices_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_IntrospectServices_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_IntrospectServices_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_IntrospectServices_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_IntrospectServices_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_IntrospectServices_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_IntrospectServices_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_IntrospectServices_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_IntrospectServices_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_IntrospectServices_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_IntrospectServices_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_IntrospectServices_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_IntrospectServices_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_IntrospectServices_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_IntrospectServices_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_IntrospectServices_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_IntrospectServices_Response_& instance_data) = 0;

            protected:
                Sample_IntrospectServices_Response_DataWriter () {};
                ~Sample_IntrospectServices_Response_DataWriter () {};
            private:
                Sample_IntrospectServices_Response_DataWriter (const Sample_IntrospectServices_Response_DataWriter &);
                Sample_IntrospectServices_Response_DataWriter & operator = (const Sample_IntrospectServices_Response_DataWriter &);
            };

            class  Sample_IntrospectServices_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_IntrospectServices_Response_DataReader_ptr _ptr_type;
                typedef Sample_IntrospectServices_Response_DataReader_var _var_type;

                static Sample_IntrospectServices_Response_DataReader_ptr _duplicate (Sample_IntrospectServices_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_IntrospectServices_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_IntrospectServices_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_IntrospectServices_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_IntrospectServices_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_IntrospectServices_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_IntrospectServices_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_IntrospectServices_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_IntrospectServices_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_IntrospectServices_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_IntrospectServices_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_IntrospectServices_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_IntrospectServices_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_IntrospectServices_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_IntrospectServices_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_IntrospectServices_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_IntrospectServices_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_IntrospectServices_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_IntrospectServices_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_IntrospectServices_Response_& instance) = 0;

            protected:
                Sample_IntrospectServices_Response_DataReader () {};
                ~Sample_IntrospectServices_Response_DataReader () {};
            private:
                Sample_IntrospectServices_Response_DataReader (const Sample_IntrospectServices_Response_DataReader &);
                Sample_IntrospectServices_Response_DataReader & operator = (const Sample_IntrospectServices_Response_DataReader &);
            };

            class  Sample_IntrospectServices_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_IntrospectServices_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_IntrospectServices_Response_DataReaderView_var _var_type;

                static Sample_IntrospectServices_Response_DataReaderView_ptr _duplicate (Sample_IntrospectServices_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_IntrospectServices_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_IntrospectServices_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_IntrospectServices_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_IntrospectServices_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_IntrospectServices_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_IntrospectServices_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_IntrospectServices_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_IntrospectServices_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_IntrospectServices_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_IntrospectServices_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_IntrospectServices_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_IntrospectServices_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_IntrospectServices_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_IntrospectServices_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_IntrospectServices_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_IntrospectServices_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_IntrospectServices_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_IntrospectServices_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_IntrospectServices_Response_& instance) = 0;

            protected:
                Sample_IntrospectServices_Response_DataReaderView () {};
                ~Sample_IntrospectServices_Response_DataReaderView () {};
            private:
                Sample_IntrospectServices_Response_DataReaderView (const Sample_IntrospectServices_Response_DataReaderView &);
                Sample_IntrospectServices_Response_DataReaderView & operator = (const Sample_IntrospectServices_Response_DataReaderView &);
            };
        }

    }

}

#endif
