#ifndef _H_988EEAD2C4E0F7EB9C6D5DB5A483F5D3_OpenBlackboardStream__H_
#define _H_988EEAD2C4E0F7EB9C6D5DB5A483F5D3_OpenBlackboardStream__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace py_trees_ros_interfaces
{
    namespace srv
    {
        namespace dds_
        {
            struct  OpenBlackboardStream_Request_
            {
                struct _variables__seq_uniq_{};
                typedef DDS_DCPSUStrSeqT< struct _variables__seq_uniq_ > _variables__seq;
                typedef DDS_DCPSUStrSeq_var< _variables__seq > _variables__seq_var;
                typedef DDS_DCPSUStrSeq_out< _variables__seq > _variables__seq_out;
                _variables__seq variables_;
                ::DDS::Boolean filter_on_visited_path_;
                ::DDS::Boolean with_activity_stream_;
            };

            typedef DDS_DCPSStruct_var<OpenBlackboardStream_Request_> OpenBlackboardStream_Request__var;
            typedef DDS_DCPSStruct_out < OpenBlackboardStream_Request_> OpenBlackboardStream_Request__out;

            struct  OpenBlackboardStream_Response_
            {
                ::DDS::String_mgr topic_;
            };

            typedef DDS_DCPSStruct_var<OpenBlackboardStream_Response_> OpenBlackboardStream_Response__var;
            typedef DDS_DCPSStruct_out < OpenBlackboardStream_Response_> OpenBlackboardStream_Response__out;

            struct  Sample_OpenBlackboardStream_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::py_trees_ros_interfaces::srv::dds_::OpenBlackboardStream_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_OpenBlackboardStream_Request_> Sample_OpenBlackboardStream_Request__var;
            typedef DDS_DCPSStruct_out < Sample_OpenBlackboardStream_Request_> Sample_OpenBlackboardStream_Request__out;

            struct  Sample_OpenBlackboardStream_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::py_trees_ros_interfaces::srv::dds_::OpenBlackboardStream_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_OpenBlackboardStream_Response_> Sample_OpenBlackboardStream_Response__var;
            typedef DDS_DCPSStruct_out < Sample_OpenBlackboardStream_Response_> Sample_OpenBlackboardStream_Response__out;

        }

    }

}

#endif /* _H_988EEAD2C4E0F7EB9C6D5DB5A483F5D3_OpenBlackboardStream__H_ */
