#ifndef _H_2A3276F20C0B381487DAE6A17DBAF5E1_ReconfigureSnapshotStream__H_
#define _H_2A3276F20C0B381487DAE6A17DBAF5E1_ReconfigureSnapshotStream__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "py_trees_ros_interfaces/msg/dds_opensplice/SnapshotStreamParameters_.h"


namespace py_trees_ros_interfaces
{
    namespace srv
    {
        namespace dds_
        {
            struct  ReconfigureSnapshotStream_Request_
            {
                ::DDS::String_mgr topic_name_;
                ::py_trees_ros_interfaces::msg::dds_::SnapshotStreamParameters_ parameters_;
            };

            typedef DDS_DCPSStruct_var<ReconfigureSnapshotStream_Request_> ReconfigureSnapshotStream_Request__var;
            typedef DDS_DCPSStruct_out < ReconfigureSnapshotStream_Request_> ReconfigureSnapshotStream_Request__out;

            struct  ReconfigureSnapshotStream_Response_
            {
                ::DDS::Boolean result_;
            };

            typedef DDS_DCPSStruct_var<ReconfigureSnapshotStream_Response_> ReconfigureSnapshotStream_Response__var;
            typedef ReconfigureSnapshotStream_Response_& ReconfigureSnapshotStream_Response__out;

            struct  Sample_ReconfigureSnapshotStream_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::py_trees_ros_interfaces::srv::dds_::ReconfigureSnapshotStream_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_ReconfigureSnapshotStream_Request_> Sample_ReconfigureSnapshotStream_Request__var;
            typedef DDS_DCPSStruct_out < Sample_ReconfigureSnapshotStream_Request_> Sample_ReconfigureSnapshotStream_Request__out;

            struct  Sample_ReconfigureSnapshotStream_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::py_trees_ros_interfaces::srv::dds_::ReconfigureSnapshotStream_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_ReconfigureSnapshotStream_Response_> Sample_ReconfigureSnapshotStream_Response__var;
            typedef Sample_ReconfigureSnapshotStream_Response_& Sample_ReconfigureSnapshotStream_Response__out;

        }

    }

}

#endif /* _H_2A3276F20C0B381487DAE6A17DBAF5E1_ReconfigureSnapshotStream__H_ */
