#ifndef _H_2A3276F20C0B381487DAE6A17DBAF5E1_ReconfigureSnapshotStream_DCPS_H_
#define _H_2A3276F20C0B381487DAE6A17DBAF5E1_ReconfigureSnapshotStream_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ReconfigureSnapshotStream_.h"


namespace py_trees_ros_interfaces
{
    namespace srv
    {
        namespace dds_
        {
            class ReconfigureSnapshotStream_Request_TypeSupportInterface;

            typedef ReconfigureSnapshotStream_Request_TypeSupportInterface * ReconfigureSnapshotStream_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ReconfigureSnapshotStream_Request_TypeSupportInterface> ReconfigureSnapshotStream_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ReconfigureSnapshotStream_Request_TypeSupportInterface> ReconfigureSnapshotStream_Request_TypeSupportInterface_out;


            class ReconfigureSnapshotStream_Request_DataWriter;

            typedef ReconfigureSnapshotStream_Request_DataWriter * ReconfigureSnapshotStream_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ReconfigureSnapshotStream_Request_DataWriter> ReconfigureSnapshotStream_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < ReconfigureSnapshotStream_Request_DataWriter> ReconfigureSnapshotStream_Request_DataWriter_out;


            class ReconfigureSnapshotStream_Request_DataReader;

            typedef ReconfigureSnapshotStream_Request_DataReader * ReconfigureSnapshotStream_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ReconfigureSnapshotStream_Request_DataReader> ReconfigureSnapshotStream_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < ReconfigureSnapshotStream_Request_DataReader> ReconfigureSnapshotStream_Request_DataReader_out;


            class ReconfigureSnapshotStream_Request_DataReaderView;

            typedef ReconfigureSnapshotStream_Request_DataReaderView * ReconfigureSnapshotStream_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ReconfigureSnapshotStream_Request_DataReaderView> ReconfigureSnapshotStream_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ReconfigureSnapshotStream_Request_DataReaderView> ReconfigureSnapshotStream_Request_DataReaderView_out;

            struct ReconfigureSnapshotStream_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ReconfigureSnapshotStream_Request_, struct ReconfigureSnapshotStream_Request_Seq_uniq_> ReconfigureSnapshotStream_Request_Seq;
            typedef DDS_DCPSSequence_var < ReconfigureSnapshotStream_Request_Seq> ReconfigureSnapshotStream_Request_Seq_var;
            typedef DDS_DCPSSequence_out < ReconfigureSnapshotStream_Request_Seq> ReconfigureSnapshotStream_Request_Seq_out;

            class  ReconfigureSnapshotStream_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ReconfigureSnapshotStream_Request_TypeSupportInterface_ptr _ptr_type;
                typedef ReconfigureSnapshotStream_Request_TypeSupportInterface_var _var_type;

                static ReconfigureSnapshotStream_Request_TypeSupportInterface_ptr _duplicate (ReconfigureSnapshotStream_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ReconfigureSnapshotStream_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ReconfigureSnapshotStream_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ReconfigureSnapshotStream_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ReconfigureSnapshotStream_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ReconfigureSnapshotStream_Request_TypeSupportInterface () {};
                ~ReconfigureSnapshotStream_Request_TypeSupportInterface () {};
            private:
                ReconfigureSnapshotStream_Request_TypeSupportInterface (const ReconfigureSnapshotStream_Request_TypeSupportInterface &);
                ReconfigureSnapshotStream_Request_TypeSupportInterface & operator = (const ReconfigureSnapshotStream_Request_TypeSupportInterface &);
            };

            class  ReconfigureSnapshotStream_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ReconfigureSnapshotStream_Request_DataWriter_ptr _ptr_type;
                typedef ReconfigureSnapshotStream_Request_DataWriter_var _var_type;

                static ReconfigureSnapshotStream_Request_DataWriter_ptr _duplicate (ReconfigureSnapshotStream_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ReconfigureSnapshotStream_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ReconfigureSnapshotStream_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ReconfigureSnapshotStream_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ReconfigureSnapshotStream_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ReconfigureSnapshotStream_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ReconfigureSnapshotStream_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ReconfigureSnapshotStream_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ReconfigureSnapshotStream_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ReconfigureSnapshotStream_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ReconfigureSnapshotStream_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ReconfigureSnapshotStream_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ReconfigureSnapshotStream_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ReconfigureSnapshotStream_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ReconfigureSnapshotStream_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ReconfigureSnapshotStream_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ReconfigureSnapshotStream_Request_& instance_data) = 0;

            protected:
                ReconfigureSnapshotStream_Request_DataWriter () {};
                ~ReconfigureSnapshotStream_Request_DataWriter () {};
            private:
                ReconfigureSnapshotStream_Request_DataWriter (const ReconfigureSnapshotStream_Request_DataWriter &);
                ReconfigureSnapshotStream_Request_DataWriter & operator = (const ReconfigureSnapshotStream_Request_DataWriter &);
            };

            class  ReconfigureSnapshotStream_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ReconfigureSnapshotStream_Request_DataReader_ptr _ptr_type;
                typedef ReconfigureSnapshotStream_Request_DataReader_var _var_type;

                static ReconfigureSnapshotStream_Request_DataReader_ptr _duplicate (ReconfigureSnapshotStream_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ReconfigureSnapshotStream_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ReconfigureSnapshotStream_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ReconfigureSnapshotStream_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ReconfigureSnapshotStream_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ReconfigureSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ReconfigureSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ReconfigureSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ReconfigureSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ReconfigureSnapshotStream_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ReconfigureSnapshotStream_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ReconfigureSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ReconfigureSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ReconfigureSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ReconfigureSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ReconfigureSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ReconfigureSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ReconfigureSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ReconfigureSnapshotStream_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ReconfigureSnapshotStream_Request_& instance) = 0;

            protected:
                ReconfigureSnapshotStream_Request_DataReader () {};
                ~ReconfigureSnapshotStream_Request_DataReader () {};
            private:
                ReconfigureSnapshotStream_Request_DataReader (const ReconfigureSnapshotStream_Request_DataReader &);
                ReconfigureSnapshotStream_Request_DataReader & operator = (const ReconfigureSnapshotStream_Request_DataReader &);
            };

            class  ReconfigureSnapshotStream_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ReconfigureSnapshotStream_Request_DataReaderView_ptr _ptr_type;
                typedef ReconfigureSnapshotStream_Request_DataReaderView_var _var_type;

                static ReconfigureSnapshotStream_Request_DataReaderView_ptr _duplicate (ReconfigureSnapshotStream_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ReconfigureSnapshotStream_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ReconfigureSnapshotStream_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ReconfigureSnapshotStream_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ReconfigureSnapshotStream_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ReconfigureSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ReconfigureSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ReconfigureSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ReconfigureSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ReconfigureSnapshotStream_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ReconfigureSnapshotStream_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ReconfigureSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ReconfigureSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ReconfigureSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ReconfigureSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ReconfigureSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ReconfigureSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ReconfigureSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ReconfigureSnapshotStream_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ReconfigureSnapshotStream_Request_& instance) = 0;

            protected:
                ReconfigureSnapshotStream_Request_DataReaderView () {};
                ~ReconfigureSnapshotStream_Request_DataReaderView () {};
            private:
                ReconfigureSnapshotStream_Request_DataReaderView (const ReconfigureSnapshotStream_Request_DataReaderView &);
                ReconfigureSnapshotStream_Request_DataReaderView & operator = (const ReconfigureSnapshotStream_Request_DataReaderView &);
            };
            class ReconfigureSnapshotStream_Response_TypeSupportInterface;

            typedef ReconfigureSnapshotStream_Response_TypeSupportInterface * ReconfigureSnapshotStream_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ReconfigureSnapshotStream_Response_TypeSupportInterface> ReconfigureSnapshotStream_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ReconfigureSnapshotStream_Response_TypeSupportInterface> ReconfigureSnapshotStream_Response_TypeSupportInterface_out;


            class ReconfigureSnapshotStream_Response_DataWriter;

            typedef ReconfigureSnapshotStream_Response_DataWriter * ReconfigureSnapshotStream_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ReconfigureSnapshotStream_Response_DataWriter> ReconfigureSnapshotStream_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < ReconfigureSnapshotStream_Response_DataWriter> ReconfigureSnapshotStream_Response_DataWriter_out;


            class ReconfigureSnapshotStream_Response_DataReader;

            typedef ReconfigureSnapshotStream_Response_DataReader * ReconfigureSnapshotStream_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ReconfigureSnapshotStream_Response_DataReader> ReconfigureSnapshotStream_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < ReconfigureSnapshotStream_Response_DataReader> ReconfigureSnapshotStream_Response_DataReader_out;


            class ReconfigureSnapshotStream_Response_DataReaderView;

            typedef ReconfigureSnapshotStream_Response_DataReaderView * ReconfigureSnapshotStream_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ReconfigureSnapshotStream_Response_DataReaderView> ReconfigureSnapshotStream_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ReconfigureSnapshotStream_Response_DataReaderView> ReconfigureSnapshotStream_Response_DataReaderView_out;

            struct ReconfigureSnapshotStream_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < ReconfigureSnapshotStream_Response_, struct ReconfigureSnapshotStream_Response_Seq_uniq_> ReconfigureSnapshotStream_Response_Seq;
            typedef DDS_DCPSSequence_var < ReconfigureSnapshotStream_Response_Seq> ReconfigureSnapshotStream_Response_Seq_var;
            typedef DDS_DCPSSequence_out < ReconfigureSnapshotStream_Response_Seq> ReconfigureSnapshotStream_Response_Seq_out;

            class  ReconfigureSnapshotStream_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ReconfigureSnapshotStream_Response_TypeSupportInterface_ptr _ptr_type;
                typedef ReconfigureSnapshotStream_Response_TypeSupportInterface_var _var_type;

                static ReconfigureSnapshotStream_Response_TypeSupportInterface_ptr _duplicate (ReconfigureSnapshotStream_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ReconfigureSnapshotStream_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ReconfigureSnapshotStream_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ReconfigureSnapshotStream_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ReconfigureSnapshotStream_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ReconfigureSnapshotStream_Response_TypeSupportInterface () {};
                ~ReconfigureSnapshotStream_Response_TypeSupportInterface () {};
            private:
                ReconfigureSnapshotStream_Response_TypeSupportInterface (const ReconfigureSnapshotStream_Response_TypeSupportInterface &);
                ReconfigureSnapshotStream_Response_TypeSupportInterface & operator = (const ReconfigureSnapshotStream_Response_TypeSupportInterface &);
            };

            class  ReconfigureSnapshotStream_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ReconfigureSnapshotStream_Response_DataWriter_ptr _ptr_type;
                typedef ReconfigureSnapshotStream_Response_DataWriter_var _var_type;

                static ReconfigureSnapshotStream_Response_DataWriter_ptr _duplicate (ReconfigureSnapshotStream_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ReconfigureSnapshotStream_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ReconfigureSnapshotStream_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ReconfigureSnapshotStream_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ReconfigureSnapshotStream_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ReconfigureSnapshotStream_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ReconfigureSnapshotStream_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ReconfigureSnapshotStream_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ReconfigureSnapshotStream_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ReconfigureSnapshotStream_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ReconfigureSnapshotStream_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ReconfigureSnapshotStream_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ReconfigureSnapshotStream_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ReconfigureSnapshotStream_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ReconfigureSnapshotStream_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ReconfigureSnapshotStream_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ReconfigureSnapshotStream_Response_& instance_data) = 0;

            protected:
                ReconfigureSnapshotStream_Response_DataWriter () {};
                ~ReconfigureSnapshotStream_Response_DataWriter () {};
            private:
                ReconfigureSnapshotStream_Response_DataWriter (const ReconfigureSnapshotStream_Response_DataWriter &);
                ReconfigureSnapshotStream_Response_DataWriter & operator = (const ReconfigureSnapshotStream_Response_DataWriter &);
            };

            class  ReconfigureSnapshotStream_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ReconfigureSnapshotStream_Response_DataReader_ptr _ptr_type;
                typedef ReconfigureSnapshotStream_Response_DataReader_var _var_type;

                static ReconfigureSnapshotStream_Response_DataReader_ptr _duplicate (ReconfigureSnapshotStream_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ReconfigureSnapshotStream_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ReconfigureSnapshotStream_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ReconfigureSnapshotStream_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ReconfigureSnapshotStream_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ReconfigureSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ReconfigureSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ReconfigureSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ReconfigureSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ReconfigureSnapshotStream_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ReconfigureSnapshotStream_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ReconfigureSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ReconfigureSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ReconfigureSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ReconfigureSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ReconfigureSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ReconfigureSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ReconfigureSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ReconfigureSnapshotStream_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ReconfigureSnapshotStream_Response_& instance) = 0;

            protected:
                ReconfigureSnapshotStream_Response_DataReader () {};
                ~ReconfigureSnapshotStream_Response_DataReader () {};
            private:
                ReconfigureSnapshotStream_Response_DataReader (const ReconfigureSnapshotStream_Response_DataReader &);
                ReconfigureSnapshotStream_Response_DataReader & operator = (const ReconfigureSnapshotStream_Response_DataReader &);
            };

            class  ReconfigureSnapshotStream_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ReconfigureSnapshotStream_Response_DataReaderView_ptr _ptr_type;
                typedef ReconfigureSnapshotStream_Response_DataReaderView_var _var_type;

                static ReconfigureSnapshotStream_Response_DataReaderView_ptr _duplicate (ReconfigureSnapshotStream_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ReconfigureSnapshotStream_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ReconfigureSnapshotStream_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ReconfigureSnapshotStream_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ReconfigureSnapshotStream_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ReconfigureSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ReconfigureSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ReconfigureSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ReconfigureSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ReconfigureSnapshotStream_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ReconfigureSnapshotStream_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ReconfigureSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ReconfigureSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ReconfigureSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ReconfigureSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ReconfigureSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ReconfigureSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ReconfigureSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ReconfigureSnapshotStream_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ReconfigureSnapshotStream_Response_& instance) = 0;

            protected:
                ReconfigureSnapshotStream_Response_DataReaderView () {};
                ~ReconfigureSnapshotStream_Response_DataReaderView () {};
            private:
                ReconfigureSnapshotStream_Response_DataReaderView (const ReconfigureSnapshotStream_Response_DataReaderView &);
                ReconfigureSnapshotStream_Response_DataReaderView & operator = (const ReconfigureSnapshotStream_Response_DataReaderView &);
            };
            class Sample_ReconfigureSnapshotStream_Request_TypeSupportInterface;

            typedef Sample_ReconfigureSnapshotStream_Request_TypeSupportInterface * Sample_ReconfigureSnapshotStream_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_ReconfigureSnapshotStream_Request_TypeSupportInterface> Sample_ReconfigureSnapshotStream_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_ReconfigureSnapshotStream_Request_TypeSupportInterface> Sample_ReconfigureSnapshotStream_Request_TypeSupportInterface_out;


            class Sample_ReconfigureSnapshotStream_Request_DataWriter;

            typedef Sample_ReconfigureSnapshotStream_Request_DataWriter * Sample_ReconfigureSnapshotStream_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_ReconfigureSnapshotStream_Request_DataWriter> Sample_ReconfigureSnapshotStream_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_ReconfigureSnapshotStream_Request_DataWriter> Sample_ReconfigureSnapshotStream_Request_DataWriter_out;


            class Sample_ReconfigureSnapshotStream_Request_DataReader;

            typedef Sample_ReconfigureSnapshotStream_Request_DataReader * Sample_ReconfigureSnapshotStream_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_ReconfigureSnapshotStream_Request_DataReader> Sample_ReconfigureSnapshotStream_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_ReconfigureSnapshotStream_Request_DataReader> Sample_ReconfigureSnapshotStream_Request_DataReader_out;


            class Sample_ReconfigureSnapshotStream_Request_DataReaderView;

            typedef Sample_ReconfigureSnapshotStream_Request_DataReaderView * Sample_ReconfigureSnapshotStream_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_ReconfigureSnapshotStream_Request_DataReaderView> Sample_ReconfigureSnapshotStream_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_ReconfigureSnapshotStream_Request_DataReaderView> Sample_ReconfigureSnapshotStream_Request_DataReaderView_out;

            struct Sample_ReconfigureSnapshotStream_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_ReconfigureSnapshotStream_Request_, struct Sample_ReconfigureSnapshotStream_Request_Seq_uniq_> Sample_ReconfigureSnapshotStream_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_ReconfigureSnapshotStream_Request_Seq> Sample_ReconfigureSnapshotStream_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_ReconfigureSnapshotStream_Request_Seq> Sample_ReconfigureSnapshotStream_Request_Seq_out;

            class  Sample_ReconfigureSnapshotStream_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_ReconfigureSnapshotStream_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_ReconfigureSnapshotStream_Request_TypeSupportInterface_var _var_type;

                static Sample_ReconfigureSnapshotStream_Request_TypeSupportInterface_ptr _duplicate (Sample_ReconfigureSnapshotStream_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ReconfigureSnapshotStream_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ReconfigureSnapshotStream_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ReconfigureSnapshotStream_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ReconfigureSnapshotStream_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_ReconfigureSnapshotStream_Request_TypeSupportInterface () {};
                ~Sample_ReconfigureSnapshotStream_Request_TypeSupportInterface () {};
            private:
                Sample_ReconfigureSnapshotStream_Request_TypeSupportInterface (const Sample_ReconfigureSnapshotStream_Request_TypeSupportInterface &);
                Sample_ReconfigureSnapshotStream_Request_TypeSupportInterface & operator = (const Sample_ReconfigureSnapshotStream_Request_TypeSupportInterface &);
            };

            class  Sample_ReconfigureSnapshotStream_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_ReconfigureSnapshotStream_Request_DataWriter_ptr _ptr_type;
                typedef Sample_ReconfigureSnapshotStream_Request_DataWriter_var _var_type;

                static Sample_ReconfigureSnapshotStream_Request_DataWriter_ptr _duplicate (Sample_ReconfigureSnapshotStream_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ReconfigureSnapshotStream_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ReconfigureSnapshotStream_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ReconfigureSnapshotStream_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ReconfigureSnapshotStream_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_ReconfigureSnapshotStream_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_ReconfigureSnapshotStream_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_ReconfigureSnapshotStream_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_ReconfigureSnapshotStream_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_ReconfigureSnapshotStream_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_ReconfigureSnapshotStream_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_ReconfigureSnapshotStream_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_ReconfigureSnapshotStream_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_ReconfigureSnapshotStream_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_ReconfigureSnapshotStream_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_ReconfigureSnapshotStream_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ReconfigureSnapshotStream_Request_& instance_data) = 0;

            protected:
                Sample_ReconfigureSnapshotStream_Request_DataWriter () {};
                ~Sample_ReconfigureSnapshotStream_Request_DataWriter () {};
            private:
                Sample_ReconfigureSnapshotStream_Request_DataWriter (const Sample_ReconfigureSnapshotStream_Request_DataWriter &);
                Sample_ReconfigureSnapshotStream_Request_DataWriter & operator = (const Sample_ReconfigureSnapshotStream_Request_DataWriter &);
            };

            class  Sample_ReconfigureSnapshotStream_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_ReconfigureSnapshotStream_Request_DataReader_ptr _ptr_type;
                typedef Sample_ReconfigureSnapshotStream_Request_DataReader_var _var_type;

                static Sample_ReconfigureSnapshotStream_Request_DataReader_ptr _duplicate (Sample_ReconfigureSnapshotStream_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ReconfigureSnapshotStream_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ReconfigureSnapshotStream_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ReconfigureSnapshotStream_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ReconfigureSnapshotStream_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ReconfigureSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ReconfigureSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ReconfigureSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ReconfigureSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ReconfigureSnapshotStream_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ReconfigureSnapshotStream_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ReconfigureSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ReconfigureSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ReconfigureSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ReconfigureSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ReconfigureSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ReconfigureSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ReconfigureSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ReconfigureSnapshotStream_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ReconfigureSnapshotStream_Request_& instance) = 0;

            protected:
                Sample_ReconfigureSnapshotStream_Request_DataReader () {};
                ~Sample_ReconfigureSnapshotStream_Request_DataReader () {};
            private:
                Sample_ReconfigureSnapshotStream_Request_DataReader (const Sample_ReconfigureSnapshotStream_Request_DataReader &);
                Sample_ReconfigureSnapshotStream_Request_DataReader & operator = (const Sample_ReconfigureSnapshotStream_Request_DataReader &);
            };

            class  Sample_ReconfigureSnapshotStream_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_ReconfigureSnapshotStream_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_ReconfigureSnapshotStream_Request_DataReaderView_var _var_type;

                static Sample_ReconfigureSnapshotStream_Request_DataReaderView_ptr _duplicate (Sample_ReconfigureSnapshotStream_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ReconfigureSnapshotStream_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ReconfigureSnapshotStream_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ReconfigureSnapshotStream_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ReconfigureSnapshotStream_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ReconfigureSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ReconfigureSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ReconfigureSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ReconfigureSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ReconfigureSnapshotStream_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ReconfigureSnapshotStream_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ReconfigureSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ReconfigureSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ReconfigureSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ReconfigureSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ReconfigureSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ReconfigureSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ReconfigureSnapshotStream_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ReconfigureSnapshotStream_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ReconfigureSnapshotStream_Request_& instance) = 0;

            protected:
                Sample_ReconfigureSnapshotStream_Request_DataReaderView () {};
                ~Sample_ReconfigureSnapshotStream_Request_DataReaderView () {};
            private:
                Sample_ReconfigureSnapshotStream_Request_DataReaderView (const Sample_ReconfigureSnapshotStream_Request_DataReaderView &);
                Sample_ReconfigureSnapshotStream_Request_DataReaderView & operator = (const Sample_ReconfigureSnapshotStream_Request_DataReaderView &);
            };
            class Sample_ReconfigureSnapshotStream_Response_TypeSupportInterface;

            typedef Sample_ReconfigureSnapshotStream_Response_TypeSupportInterface * Sample_ReconfigureSnapshotStream_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_ReconfigureSnapshotStream_Response_TypeSupportInterface> Sample_ReconfigureSnapshotStream_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_ReconfigureSnapshotStream_Response_TypeSupportInterface> Sample_ReconfigureSnapshotStream_Response_TypeSupportInterface_out;


            class Sample_ReconfigureSnapshotStream_Response_DataWriter;

            typedef Sample_ReconfigureSnapshotStream_Response_DataWriter * Sample_ReconfigureSnapshotStream_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_ReconfigureSnapshotStream_Response_DataWriter> Sample_ReconfigureSnapshotStream_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_ReconfigureSnapshotStream_Response_DataWriter> Sample_ReconfigureSnapshotStream_Response_DataWriter_out;


            class Sample_ReconfigureSnapshotStream_Response_DataReader;

            typedef Sample_ReconfigureSnapshotStream_Response_DataReader * Sample_ReconfigureSnapshotStream_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_ReconfigureSnapshotStream_Response_DataReader> Sample_ReconfigureSnapshotStream_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_ReconfigureSnapshotStream_Response_DataReader> Sample_ReconfigureSnapshotStream_Response_DataReader_out;


            class Sample_ReconfigureSnapshotStream_Response_DataReaderView;

            typedef Sample_ReconfigureSnapshotStream_Response_DataReaderView * Sample_ReconfigureSnapshotStream_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_ReconfigureSnapshotStream_Response_DataReaderView> Sample_ReconfigureSnapshotStream_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_ReconfigureSnapshotStream_Response_DataReaderView> Sample_ReconfigureSnapshotStream_Response_DataReaderView_out;

            struct Sample_ReconfigureSnapshotStream_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_ReconfigureSnapshotStream_Response_, struct Sample_ReconfigureSnapshotStream_Response_Seq_uniq_> Sample_ReconfigureSnapshotStream_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_ReconfigureSnapshotStream_Response_Seq> Sample_ReconfigureSnapshotStream_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_ReconfigureSnapshotStream_Response_Seq> Sample_ReconfigureSnapshotStream_Response_Seq_out;

            class  Sample_ReconfigureSnapshotStream_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_ReconfigureSnapshotStream_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_ReconfigureSnapshotStream_Response_TypeSupportInterface_var _var_type;

                static Sample_ReconfigureSnapshotStream_Response_TypeSupportInterface_ptr _duplicate (Sample_ReconfigureSnapshotStream_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ReconfigureSnapshotStream_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ReconfigureSnapshotStream_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ReconfigureSnapshotStream_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ReconfigureSnapshotStream_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_ReconfigureSnapshotStream_Response_TypeSupportInterface () {};
                ~Sample_ReconfigureSnapshotStream_Response_TypeSupportInterface () {};
            private:
                Sample_ReconfigureSnapshotStream_Response_TypeSupportInterface (const Sample_ReconfigureSnapshotStream_Response_TypeSupportInterface &);
                Sample_ReconfigureSnapshotStream_Response_TypeSupportInterface & operator = (const Sample_ReconfigureSnapshotStream_Response_TypeSupportInterface &);
            };

            class  Sample_ReconfigureSnapshotStream_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_ReconfigureSnapshotStream_Response_DataWriter_ptr _ptr_type;
                typedef Sample_ReconfigureSnapshotStream_Response_DataWriter_var _var_type;

                static Sample_ReconfigureSnapshotStream_Response_DataWriter_ptr _duplicate (Sample_ReconfigureSnapshotStream_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ReconfigureSnapshotStream_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ReconfigureSnapshotStream_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ReconfigureSnapshotStream_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ReconfigureSnapshotStream_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_ReconfigureSnapshotStream_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_ReconfigureSnapshotStream_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_ReconfigureSnapshotStream_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_ReconfigureSnapshotStream_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_ReconfigureSnapshotStream_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_ReconfigureSnapshotStream_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_ReconfigureSnapshotStream_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_ReconfigureSnapshotStream_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_ReconfigureSnapshotStream_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_ReconfigureSnapshotStream_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_ReconfigureSnapshotStream_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ReconfigureSnapshotStream_Response_& instance_data) = 0;

            protected:
                Sample_ReconfigureSnapshotStream_Response_DataWriter () {};
                ~Sample_ReconfigureSnapshotStream_Response_DataWriter () {};
            private:
                Sample_ReconfigureSnapshotStream_Response_DataWriter (const Sample_ReconfigureSnapshotStream_Response_DataWriter &);
                Sample_ReconfigureSnapshotStream_Response_DataWriter & operator = (const Sample_ReconfigureSnapshotStream_Response_DataWriter &);
            };

            class  Sample_ReconfigureSnapshotStream_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_ReconfigureSnapshotStream_Response_DataReader_ptr _ptr_type;
                typedef Sample_ReconfigureSnapshotStream_Response_DataReader_var _var_type;

                static Sample_ReconfigureSnapshotStream_Response_DataReader_ptr _duplicate (Sample_ReconfigureSnapshotStream_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ReconfigureSnapshotStream_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ReconfigureSnapshotStream_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ReconfigureSnapshotStream_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ReconfigureSnapshotStream_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ReconfigureSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ReconfigureSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ReconfigureSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ReconfigureSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ReconfigureSnapshotStream_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ReconfigureSnapshotStream_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ReconfigureSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ReconfigureSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ReconfigureSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ReconfigureSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ReconfigureSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ReconfigureSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ReconfigureSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ReconfigureSnapshotStream_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ReconfigureSnapshotStream_Response_& instance) = 0;

            protected:
                Sample_ReconfigureSnapshotStream_Response_DataReader () {};
                ~Sample_ReconfigureSnapshotStream_Response_DataReader () {};
            private:
                Sample_ReconfigureSnapshotStream_Response_DataReader (const Sample_ReconfigureSnapshotStream_Response_DataReader &);
                Sample_ReconfigureSnapshotStream_Response_DataReader & operator = (const Sample_ReconfigureSnapshotStream_Response_DataReader &);
            };

            class  Sample_ReconfigureSnapshotStream_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_ReconfigureSnapshotStream_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_ReconfigureSnapshotStream_Response_DataReaderView_var _var_type;

                static Sample_ReconfigureSnapshotStream_Response_DataReaderView_ptr _duplicate (Sample_ReconfigureSnapshotStream_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ReconfigureSnapshotStream_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ReconfigureSnapshotStream_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ReconfigureSnapshotStream_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ReconfigureSnapshotStream_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ReconfigureSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ReconfigureSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ReconfigureSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ReconfigureSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ReconfigureSnapshotStream_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ReconfigureSnapshotStream_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ReconfigureSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ReconfigureSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ReconfigureSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ReconfigureSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ReconfigureSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ReconfigureSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ReconfigureSnapshotStream_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ReconfigureSnapshotStream_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ReconfigureSnapshotStream_Response_& instance) = 0;

            protected:
                Sample_ReconfigureSnapshotStream_Response_DataReaderView () {};
                ~Sample_ReconfigureSnapshotStream_Response_DataReaderView () {};
            private:
                Sample_ReconfigureSnapshotStream_Response_DataReaderView (const Sample_ReconfigureSnapshotStream_Response_DataReaderView &);
                Sample_ReconfigureSnapshotStream_Response_DataReaderView & operator = (const Sample_ReconfigureSnapshotStream_Response_DataReaderView &);
            };
        }

    }

}

#endif
